obj/Barracades
	density=1
	HP=50;MaxHP=50
	mouse_opacity=2
	var/mob/Owner
	var/secured="Don't Use This!"	//left here due to map errors...
	var/Secured=0
	New()
		if(src.Secured)	src.loc.density=1
		src.verbs-=/obj/Barracades/verb/Repair
		if(!src.CanBeMoved)
			src.verbs-=/obj/Barracades/verb/Pull
			src.verbs-=/obj/Barracades/verb/Secure
	Desk
		icon='objects.dmi'
		icon_state="Desk"
		HP=25;MaxHP=25
	Military_Barracade
		icon='Barracades.dmi'
		icon_state="Military Barracade"
	Fence
		CanBeMoved=0
		icon='cityturfs.dmi'
		icon_state="Fence"
		density=1;Secured=1
	Cement_Block
		CanBeMoved=0
		HP=250;MaxHP=250
		icon='Barracades.dmi'
		icon_state="Cement Block"
		density=1;Secured=1
	Support_Barracade
		icon='Barracades.dmi'
		icon_state="Support Barracade"
		Energy_Barrier
			HP=500;MaxHP=500
			icon_state="Energy Barrier"
	Portable_Barracade
		icon='cityturfs.dmi'
		icon_state="Portable Barracade"
		mouse_opacity=2
		Get()
			usr.GenericGet(src)
		verb/Drop()
			usr.GenericDrop(src)
	DblClick()
		if(get_dist(usr,src)==1)	src.Pull()
		return ..()

	verb
		Jump()
			set hidden=1
			set src in oview(1)
			if(!usr.CanAct)	return
			usr.GenericLoc(src)
		Pull()
			set src in oview(1)
			usr.density=0
			src.loc.density=0
			if(usr.loc.Enter(src))	src.loc=usr.loc
			if(src.Secured)	src.loc.density=1
			usr.density=1
		Secure()
			set src in oview(1)
			if(src.Secured)
				src.Secured=0
				src.icon_state="[src.name]"
				src.loc.density=0
			else
				if(usr)	src.dir=usr.dir
				src.Secured=1
				src.icon_state="Secure[src.name]"
				src.loc.density=1
		Repair()
			set src in oview(1)
			src.RepairProc(usr)

proc/BarracadeBreak(var/obj/Barracades/B)
	if(istype(B,/obj/Barracades/Support_Barracade))
		B.loc.density=0
		del B;return
	B.Secured=0
	B.density=0
	B.loc.density=0
	B.icon_state="Broken[B.name]"
	B.verbs+=/obj/Barracades/verb/Repair
	B.verbs-=/obj/Barracades/verb/Jump
	B.verbs-=/obj/Barracades/verb/Secure
	B.verbs-=/obj/Barracades/verb/Pull


obj/var
	HP
	MaxHP
	RepairedAmt
	CanBeMoved=1
	BeingRepaired

obj/proc/FinishRepair(var/mob/M)
	src.HP=src.MaxHP
	src.density=1;src.loc.density=1
	if(M && istype(src,/obj/Barracades))	M.GiveVal(5)
	if(istype(src,/obj/TurfType))	//doos & windows
		src.icon_state="[src.name]";src.loc:State=""
		src.verbs-=/obj/TurfType/verb/Repair
		if(istype(src,/obj/TurfType/Door))
			src:broken=0;src.SetOpacity(1)
	else	//barracades
		src:Secured=1
		src.icon_state="[src.name]"
		src.verbs+=/obj/Barracades/verb/Jump
		src.verbs-=/obj/Barracades/verb/Repair
		if(src.CanBeMoved)
			src.icon_state="Secure[src.name]"
			src.verbs+=/obj/Barracades/verb/Secure
			src.verbs+=/obj/Barracades/verb/Pull
	src.RepairedAmt=0
	src.BeingRepaired=0
	src.overlays=list()

obj/proc/RepairProc(var/mob/M)
	if(src.HP<=0 && !src.BeingRepaired)
		var/CanRepair=0
		for(var/obj/Items/Repair_Kit/O in M.contents)	CanRepair+=1
		if("MacGyver" in M.Skills)	CanRepair+=1
		if(M.Class=="Engineer")	CanRepair+=1
		var/RepairMax=30;if("Mechanical" in M.Skills)	RepairMax=15
		if(CanRepair>=1)
			src.BeingRepaired=1
			while(M && get_dist(M,src)<=1 && src.HP<=0)
				src.RepairedAmt+=1
				src.UpdateCapBar(src.RepairedAmt)
				if(src.RepairedAmt>=RepairMax)	break
				sleep(5)
			if(src.RepairedAmt>=RepairMax)	src.FinishRepair(M)
			else
				src.RepairedAmt=0
				src.BeingRepaired=0
				src.overlays=list()
		else	M<<"You dont have the proper tools to Repair!"
