var/list/CashPointPurchases=list()

mob/var/CashPoints=0
mob/var/CanGetCashPoints=0
mob/var/list/CashPointsReceived=list()

obj/var/CashPointed=0

var/obj/Supplemental/CashPointsLink/CashPointsLink=new
obj/Supplemental
	CashPointsLink
		name="<font color=blue>Click Here for $ Point Info"
		Click()
			usr<<link("http://www.angelfire.com/hero/straygames/CashPoints.html")

proc/LoadCashPointPurchases(var/Loop=1)
	var/http[]=world.Export("http://www.angelfire.com/hero/straygames/ZPointPurchases.txt")
	if(!http)	//Site could not be contacted
		if(Loop)	spawn(600)	LoadCashPointPurchases()
		return
	var/F=file2text(http["CONTENT"])
	if(copytext(F,1,2)!="B")	//Invalid site reached?
		if(Loop)	spawn(600)	LoadCashPointPurchases()
		return
	CashPointPurchases=list()
	var/counter=1
	while(findtext(F,CRGRTN,counter,0))
		var/ThisLine=copytext(F,counter,findtext(F,CRGRTN,counter,0))
		var/list/SplitList=Split(ThisLine,"/")
		for(var/x in SplitList)	CashPointPurchases+=x
		counter=findtext(F,CRGRTN,counter,0)+1
	world<<"<b><font color=green>Server Info:</font> Cash Point Purchases Successfully Loaded"
	for(var/mob/Player/M in world)	M.CashPointPurchaseInfo()
	if(Loop)	spawn(36000)	LoadCashPointPurchases()

mob/proc/CashPointPurchaseInfo(/**/)
	var/KeyLocation=0
	if(!src.CanGetCashPoints)	return
	while(CashPointPurchases.Find(src.key,KeyLocation+1,0))
		KeyLocation=CashPointPurchases.Find(src.key,KeyLocation+1,0)
		var/CashPointsAmt=CashPointPurchases[KeyLocation+1]
		var/PurchaseID=CashPointPurchases[KeyLocation+2]
		if(!(PurchaseID in src.CashPointsReceived))
			var/Amt2Give=text2num(CashPointsAmt)
			if(Amt2Give>=0)
				src.CashPoints+=Amt2Give
				src.CashPointsReceived+=PurchaseID
				src<<"[Amt2Give] $ Points Received!"
			else
				src.CashPoints=0
				src.CashPointsReceived+=PurchaseID
				src<<"$ Points & Items Stripped for Fraud"
				for(var/obj/O in src.contents)
					if(!O.CashPointed)
						src.contents-=O;del O
						src<<"Lost: [O]"
				if(src.client)	del src.client
				else	del src