var/obj/ClassIcons/Medic/MedicIcon=new()
var/obj/ClassIcons/Support/SupportIcon=new()
var/obj/ClassIcons/Engineer/EngineerIcon=new()
var/obj/ClassIcons/Commander/CommanderIcon=new()
var/obj/ClassIcons/Ninja/NinjaIcon=new()
var/obj/ClassIcons/Sub/SubIcon=new()

obj/ClassIcons
	pixel_y=-8
	icon='Effects.dmi'
	New()
		src.icon_state=src.name
		return ..()
	Medic
	Support
	Engineer
	Commander
	Ninja
	Sub

mob/verb
	ClassSkill1()
		set hidden=1
		if(!usr.CanAct)	return
		if(usr.loc in block(locate(77,190,1),locate(129,194,1)))	return
		if(usr.Class=="Medic")
			for(var/obj/ClassItems/C in world)
				if(C.Owner==usr)	del C
			if("Class Upgrade A" in usr.Skills)	new/obj/ClassItems/Medic_Station(usr)
			else	new/obj/ClassItems/Medic_Kit(usr)
		if(usr.Class=="Support")
			for(var/obj/ClassItems/C in world)
				if(C.Owner==usr)	del C
			if("Class Upgrade A" in usr.Skills)	new/obj/ClassItems/Support_Kits/Fire_Ammo(usr)
			else	new/obj/ClassItems/Support_Kits/Support_Kit(usr)
		if(usr.Class=="Engineer")
			for(var/mob/Player/Drones/Turret/T in world)	if(T.Owner==usr)	{del T;return}
			for(var/mob/Player/Drones/Rocket_Turret/T in world)	if(T.Owner==usr)	{del T;return}
			if("Class Upgrade A" in usr.Skills)	new/mob/Player/Drones/Rocket_Turret(usr)
			else	new/mob/Player/Drones/Turret(usr)
		if(usr.Class=="Commander")
			if(usr.SwatTrooper)	{del usr.SwatTrooper;return}
			var/mob/Player/SWAT_Trooper/T=new(usr.loc)
			T.Owner=usr;T.density=0;walk_to(T,usr,1)
			usr.ApplySwat(T);usr.SwatTrooper=T
			spawn()	if(usr && T)	if("Class Upgrade A" in usr.Skills)	{T.MaxUpgradeWeapon();T.Reload()}
		if(usr.Class=="Ninja")	usr.Knife()

	ClassSkill2()
		set hidden=1
		if(usr.Class!="Medic" || !("Class Upgrade B" in usr.Skills))
			if(!usr.CanAct)	return
		if(usr.loc in block(locate(77,190,1),locate(129,194,1)))	return
		if(usr.Class=="Medic")
			if("Class Upgrade B" in usr.Skills)
				for(var/mob/Player/M in view(1,usr))	if(M.Downed)	M.RevivePlayer(usr)
			else
				for(var/mob/Player/M in oview(1,usr))	if(M.Downed)	M.RevivePlayer(usr)
		if(usr.Class=="Support")
			for(var/obj/Barracades/B in usr.loc)	return
			for(var/x in usr.Barracades)
				if(!x)	usr.Barracades-=x
			if(usr.Barracades.len>=5)
				var/obj/FirstBar=usr.Barracades[1]
				FirstBar.loc.density=0;del FirstBar
			var/obj/Barracades/Support_Barracade/B=new(usr.loc)
			if("Class Upgrade B" in usr.Skills)	{del B;B=new/obj/Barracades/Support_Barracade/Energy_Barrier(usr.loc)}
			B.Secure();usr.Barracades+=B
			B.Owner=usr;B.AddName(usr.name)
		if(usr.Class=="Engineer")
			var/list/ViewList;if("Class Upgrade B" in usr.Skills)	ViewList=oview(WorldView,usr)
			else	ViewList=oview(1,usr)
			for(var/obj/Barracades/B in ViewList)
				if(B.HP<=0)	{B.RepairedAmt=30;B.RepairProc(usr)}
			for(var/obj/TurfType/T in ViewList)
				if(T.HP<=0)	{T.RepairedAmt=30;T.RepairProc(usr)}
		if(usr.Class=="Commander")
			if("Class Upgrade B" in usr.Skills)
				for(var/obj/Command_Posts/Command_Post/P in oview(WorldView,usr))	{P.CapturedAmt=30;CaptureCP(P,src)}
				for(var/mob/Player/Recap_Post/P in oview(WorldView,usr))	{P.CapturedAmt=30;CaptureCP(P,src)}
			else
				for(var/obj/Command_Posts/Command_Post/P in oview(1,usr))	if(P.CapturedAmt>0)	P.CapturedAmt=30
				for(var/mob/Player/Recap_Post/P in oview(1,usr))	if(P.CapturedAmt>0)	P.CapturedAmt=30
		if(usr.Class=="Ninja")
			if(!usr.CanInvis)	return
				//usr<<"60 Second Recharge Period..."
			usr<<sound('NVG.ogg');usr<<sound('NVG.ogg')
			usr.MyInvis=1;usr.icon=InvisIcon
			usr.CanInvis=0;usr.AddHead()
			var/list/UpgradeTime=0;if("Class Upgrade B" in usr.Skills)	UpgradeTime=300
			spawn(300+UpgradeTime)
				if(usr)	{usr.MyInvis=0;usr.icon='Player.dmi';usr<<sound('click.ogg');usr.AddHead()}
			spawn(600+UpgradeTime)	if(usr)	usr.CanInvis=1

mob/proc/ClassItemDelete()
	for(var/obj/Barracades/Support_Barracade/B in world)
		if(B.Owner==src)	{B.loc.density=0;del B}
	for(var/obj/ClassItems/C in world)
		if(C.Owner==src)	del C
	for(var/mob/Player/Drones/D in world)
		if(D.Owner==src)	del D
	if(src.SwatTrooper)	del src.SwatTrooper

mob/proc/GrenadeRestockReset()
	spawn(50)	src.GrenadeRestock=0

obj/ClassItems
	icon='guns.dmi'
	var/mob/Player/Owner
	Support_Kits
		Support_Kit
			icon_state="Support Box"
		Fire_Ammo
			icon_state="Fire Ammo"
		New(var/mob/S)
			src.loc=S.loc;src.Owner=S;src.AddName(S.name)
			spawn()
				while(src && src.Owner)
					sleep(1)
					if(!src || !src.Owner)	break
					for(var/mob/Player/M in oview(1,src))
						if(src.name=="Fire Ammo")	M.FireAmmo=1
						if(M.Weapon)	if(M.Weapon.AmmoType.Ammo<M.Weapon.AmmoType.MaxAmmo)
							M.Weapon.AmmoType.Ammo+=M.Weapon.MaxAmmo
							M.Weapon.AmmoType.Ammo=min(M.Weapon.AmmoType.MaxAmmo,M.Weapon.AmmoType.Ammo)
							M.ReloadHUD();spawn()	if(M && M.Weapon && M.Weapon.Ammo<=0)	M.Reload()
						if(!M.GrenadeRestock)
							M.GrenadeRestock=1
							M.GrenadeRestockReset()
							var/MaxGrenades=3
							if("Grenades" in M.Skills)	MaxGrenades=5
							if(M.Grenades<MaxGrenades)
								M.Grenades=min(MaxGrenades,M.Grenades+1)
								M.SubWeaponHUD()
				del src
			return ..()

	Medic_Kit
		icon_state="Medic Box"
		New(var/mob/S)
			src.loc=S.loc;src.Owner=S;src.AddName(S.name)
			spawn()
				while(src && src.Owner)
					sleep(1)
					if(!src || !src.Owner)	break
					for(var/mob/Player/M in oview(1,src))
						if(M.Infected)
							M.Infected=0;M.overlays-=VirusIcon
						if(M.HP<M.MaxHP)
							M.GiveHP(1)
				del src
			return ..()
	Medic_Station
		icon_state="Medic Station"
		New(var/mob/S)
			src.loc=S.loc;src.Owner=S;src.AddName(S.name)
			spawn()
				while(src && src.Owner)
					sleep(1);if(!src.Owner)	break
					for(var/mob/Player/M in oview(1,src))
						if(M.Infected)	{M.Infected=0;M.overlays-=VirusIcon}
						if(M.HP<M.MaxHP)	{M.GiveHP(2)}
				del src
			return ..()