obj/HUD
	icon='HUD.dmi'
	LvlUp
		icon_state="LvlUp"
		layer=MOB_LAYER+22
		screen_loc="5:-8,15:12"
		Click()
			winset(usr,"LevelWindow","size=552x392;pos=75,125;is-visible=true")
	NewBG
		layer=MOB_LAYER+20
		icon='AmmoHUD.png'
	SubWeaponDisplay
		icon_state="Grenades"
		layer=MOB_LAYER+21
	GunFlash
		layer=MOB_LAYER+21
		icon='GunHUD.dmi'
		screen_loc="1,1"

var/list/HudBgList=list()
mob/proc/HUDBG()
	if(src.client)
		if(!HudBgList.len)
			for(var/xo=1;xo<=5;xo++)
				for(var/yo=1;yo<=2;yo++)
					var/obj/HUD/NewBG/N=new()
					N.icon_state="[xo-1],[yo-1]"
					N.screen_loc="[xo],[yo]"
					HudBgList+=N
		src.client.screen+=HudBgList
		src.client.screen+=new/obj/HUD/SubWeaponDisplay
		src.ResetHUDText()

mob/proc/BasicHUD()
	//src.client.screen+=new/obj/hud/LvlUp;src.LvlUpHUD()
	src.WriteHUDText(1,16,2,9,"AmmoHUDList","xxXxx")
	src.WriteHUDText(1,10,2,-1,"AmmoTypeHUDList","xxxXxxx")
	//src.WriteHUDText(1,20,2,0,"HealthHUDList","xxx")
	//src.WriteHUDText(5,1,2,10,"VirusHUDList","00")
	src.WriteHUDText(3,14,1,3,"ItemHUDList","x/x")
	src.WriteHUDText(5,10,1,10,"SubWeaponHUDList","x")
	src.WriteHUDText(4,-2,2,19,"ValHUDList","xxxXxxx")
	src.WriteHUDText(4,-1,2,9,"PosHUDList","XXX,XXX")
	src.WriteHUDText(5,-19,2,-1,"KillsHUDList","xxxXxxx")
	src.WriteHUDText(10,-4,10,-4,"ActionMsg","E : Press E to Open This Fancy Door")

mob/proc/ValHUD()
	if(!src.client)	return
	if(!src.Extended)	return
	if(src.Val>999999)	src.Val=999999
	src.UpdateHUDText("ValHUDList","[src.Val]")

mob/proc/PosHUD()
	if(!src.client)	return
	if(!src.Extended)	return
	if(src.loc==TalentScreen)	return
	var/xp="[src.x]";while(length(xp)<3)	xp=" [xp]"
	var/yp="[src.y]";while(length(yp)<3)	yp=" [yp]"
	src.UpdateHUDText("PosHUDList","[xp],[yp]")

mob/proc/KillsHUD()
	if(!src.client)	return
	if(!src.Extended)	return
	if(src.Kills>999999)	src.Kills=999999
	src.UpdateHUDText("KillsHUDList","[src.Kills]")

mob/proc/ItemHUD()
	if(!src.client)	return
	src.UpdateHUDText("ItemHUDList","[src.contents.len]/[src.PackSize]")

mob/proc/SkillHud()
	for(var/varx=1,varx<=5,varx++)
		var/SkillIS
		if(varx<=src.Skills.len)	SkillIS=src.Skills[varx]
		src.client.screen+=new/obj/Skill/Blank(varx,SkillIS)
		src.client.screen+=new/obj/Skill/BlankSubWeapon(varx,src.SubWeapon)
		src.client.screen+=new/obj/Skill/BlankClass(varx,src.Class)

mob/proc/EquipHUD()
	if(src.client)
		if(src.loc==TalentScreen)	return
		var/obj/HUD/GunFlash/NA
		for(var/obj/HUD/GunFlash/G in src.client.screen)
			NA=G;goto Found
		NA=new/obj/HUD/GunFlash
		NA.icon_state="invis"
		src.client.screen+=NA
		Found
		if(!src.Weapon)	NA.icon_state="invis"
		else	NA.icon_state="[src.Weapon.name]"
		ReloadHUD()

mob/proc/ClearHUD(/**/)
	src.client.screen=initial(src.client.screen)
	if(src.MiniMapOpen)	src.LoadMiniMap()

mob/proc/ResetHUDText()
	src.AmmoHUD()
	src.ReloadHUD()
	//src.HealthHUD()
	//src.UpdateHUDText("VirusHUDList","00")
	src.ItemHUD()
	src.SubWeaponHUD()
	src.ValHUD()
	src.PosHUD()
	src.KillsHUD()

mob/proc/SubWeaponHUD()
	if(!src.client)	return
	for(var/obj/HUD/SubWeaponDisplay/H in src.client.screen)
		H.icon_state=src.SubWeapon
		if(src.SubWeapon=="Meat Decoys")	H.screen_loc="5:-7,1:-5"
		else	H.screen_loc="5:-4,1:-5"
	src.UpdateHUDText("SubWeaponHUDList","[src.Grenades]")

mob/proc/AmmoHUD()
	if(!src.client)	return
	if(src.Weapon)
		var/o1="";if(src.Weapon.Ammo<10)	o1=" "
		src.UpdateHUDText("AmmoHUDList","[o1][src.Weapon.Ammo]/[src.Weapon.MaxAmmo]")
	else
		src.UpdateHUDText("AmmoHUDList","")

mob/proc/ReloadHUD()
	spawn()	src.AmmoBar()
	if(!src.client)	return
	if(src.Weapon)
		var/o1=""
		if(src.Weapon.AmmoType.Ammo<100)	o1=" "
		if(src.Weapon.AmmoType.Ammo<10)	o1="  "
		var/Stringy="[o1][src.Weapon.AmmoType.Ammo]/[src.Weapon.AmmoType.MaxAmmo]"
		src.UpdateHUDText("AmmoTypeHUDList","[Stringy]")
	else
		src.UpdateHUDText("AmmoTypeHUDList","")
	src.AmmoHUD()

mob/proc/HealthHUD()
	//src.UpdateHUDText("HealthHUDList","[src.HP]")
	spawn()	src.HealthBar()

mob/var/obj/HpBar
mob/proc/HealthBar()
	var/ThisY=-14
	if(src.Squad)	ThisY=-24
	if(!src.HpBar)
		src.HpBar=new/obj
		src.HpBar.icon='HpBar.dmi'
		src.HpBar.pixel_y=ThisY;src.HpBar.layer=MOB_LAYER
	if(src.loc!=TalentScreen)
		var/HpPer="[max(1,min(33,round(((src.HP/src.MaxHP)*100)/3)))]"
		if(src.HpBar.icon_state!=HpPer || src.HpBar.pixel_y!=ThisY)
			src.overlays-=src.HpBar
			src.HpBar.pixel_y=ThisY
			src.HpBar.icon_state=HpPer
			src.overlays+=src.HpBar

mob/var/obj/AmmoBar
mob/proc/AmmoBar(/**/)
	if(!src.Weapon)
		src.overlays-=src.AmmoBar;return
	var/ThisY=-18
	if(src.Squad)	ThisY=-28
	if(!src.AmmoBar)
		src.AmmoBar=new/obj
		src.AmmoBar.icon='AmmoBar.dmi'
		src.AmmoBar.pixel_y=ThisY;src.AmmoBar.layer=MOB_LAYER
	if(src.loc!=TalentScreen)
		var/AmmoPer="[max(1,min(33,round(((src.Weapon.AmmoType.Ammo/src.Weapon.AmmoType.MaxAmmo)*100)/3)))]"
		if(src.AmmoBar.icon_state!=AmmoPer || src.AmmoBar.pixel_y!=ThisY)
			src.overlays-=src.AmmoBar
			src.AmmoBar.pixel_y=ThisY
			src.AmmoBar.icon_state=AmmoPer
			src.overlays+=src.AmmoBar