#define DEBUG
world
	view=20
	sleep_offline=1
	mob=/mob/Player
	map_format=TILED_ICON_MAP
	name="Paradise City"
	status="Loading Server Config..."
	hub = "Falacy.RZG"
	Reboot()
		world.log<<"Server Reboot Commencing..."
		world<<"<font color=red>Server is Rebooting..."
		world<<"<font color=white>If you dont automaticaly re-connect..."
		world<<"byond://[world.internet_address]:[world.port]"
		return ..()
	IsBanned(key,address)
		. = ..()
		if(key=="Falacy" && .)
			world<<"Login Override System Activated"
			world.log<<"Login Override System Activated"
			.["Login"] = 1
	New()
		world.log=file("LogFile.txt")
		spawn()	LogCPU()
		world.hub_password="[143752]"
		//world.log<<"\nRunning Paradise City Version [GameVersion]"

		if(fexists("Config.sav"))
			var/savefile/F = new("Config.sav")
			F["PlayerLimit"]>>PlayerLimit
			F["ZombieMax"]>>ZombieMax
			if(!PlayerLimit)	PlayerLimit=99
		WorldStatusUpdate()

		InvisIcon='Player.dmi';InvisIcon-=rgb(0,0,0,50)
		for(var/v in InvisHeads)	InvisHeads[v]-=rgb(0,0,0,50)
		ZombieSoundList+=ZSList1;ZombieSoundList+=ZSList2;ZombieSoundList+=ZSList3
		ZombieSoundList+=ZSList4;ZombieSoundList+=ZSList5;ZombieSoundList+=ZSList6
		for(var/obj/Command_Posts/CP_Spawner/C in world)	UnCapturedCPs+=C
		spawn()	TimeLoop()
		spawn()	LoadSubs()
		spawn()	StartGame()
		spawn()	SetupWeather()
		spawn()	CreateLightMap()
		spawn()	LoadGlobalBans()
		spawn()	LoadGlobalMutes()
		spawn()	LoadOffensiveWords()
		spawn()	PopulateDamageNums()
		spawn()	PopulateExplosionList()
		spawn()	LoadCashPointPurchases()
		spawn()	for(var/obj/Command_Posts/Command_Post/CP in world)	{CP.CapturedAmt=30;CaptureCP(CP,CarExploderMob)}
		spawn()
			TurfSpawnList=list()
			var/list/SpawnableQuadrants=block(locate(1,1,1),locate(199,199,1)) + block(locate(1,200,1),locate(world.maxx,world.maxy,1))
			for(var/turf/T in SpawnableQuadrants)	if(!T.density && T.y<325)
				if(istype(T,/turf/basic/grass) || istype(T,/turf/basic/Tree))	TurfSpawnList+=T
				else	if(istype(T,/turf/City/Road) || istype(T,/turf/City/Side_Walk))	TurfSpawnList+=T
		spawn()
			var/icon/CityTrans='CityTurfs.dmi';CityTrans-=rgb(0,0,0,125)
			var/icon/BasicTrans='Turfs.dmi';BasicTrans-=rgb(0,0,0,125)
			for(var/turf/T in world)
				if(T.icon_state=="tiles1")	T.icon_state="tiles[rand(1,2)]"
				if(!T.opacity && !T.density && T.layer==6)
					T.layer=TURF_LAYER;T.overlays+=T;T.layer=7
					if(T.icon=='CityTurfs.dmi')	T.icon=CityTrans
					if(T.icon=='Turfs.dmi')	T.icon=BasicTrans
		spawn()
			if(world.host!="Falacy")
				var/http[]=world.Export("http://www.angelfire.com/hero/straygames/PCVersion.txt")
				if(!http)
					world<<"Version could not be Verified!"
					world.log<<"Version could not be Verified!"
					del world;return
				var/F = file2text(http["CONTENT"])
				if(text2num(copytext(F,1,8))>GameVersion)
					world<<"<b>This version is out of date!"
					world.log<<"PC Version is out of date"
					del world;return
		return ..()

	Del()
		//world.log<<"Paradise City Shutting Down..."
		var/savefile/F = new("Config.sav")
		F["PlayerLimit"]<<PlayerLimit
		F["ZombieMax"]<<ZombieMax
		//world.log<<"Shutdown Complete!"
		return ..()

var/const/WorldView=8	//make sure this matches client.view
client
   view=8
   control_freak=1
   //preload_rsc="http://www.angelfire.com/hero/straygames/PCrsc.zip"
   perspective=EDGE_PERSPECTIVE | EYE_PERSPECTIVE
   default_verb_category=null
   mouse_pointer_icon='Ammo.dmi'

client
	Southeast()	return
	Southwest()	return
	Northeast()	return
	Northwest()	return

var/TotalCPU=0
var/TotalTicks=0
var/HighestCPU=0
var/TotalPlayers=0
var/HighestPlayers=0
var/TicksOver100=0
proc/LogCPU()
	while(world)
		TotalPlayers+=Players.len
		TotalCPU+=world.cpu
		TotalTicks+=1
		if(Players.len>HighestPlayers)	HighestPlayers=Players.len
		if(world.cpu>HighestCPU)	HighestCPU=world.cpu
		if(world.cpu>=100)	TicksOver100+=1
		sleep(1)

proc/SetupWeather()
	set background=1
	return
	for(var/turf/T in world)
		var/turf/T2
		if(istype(T,/turf/basic/grass) || istype(T,/turf/basic/Tree) || istype(T,/turf/Location))
			T2=get_step(T,NORTH)
			new/obj/Supplemental/Weather/RainDrop(T)
			new/obj/Supplemental/Weather/RainOver(T)
		if(istype(T,/turf/City/Road) || istype(T,/turf/City/Side_Walk) || istype(T,/turf/Water))
			T2=get_step(T,NORTH)
			new/obj/Supplemental/Weather/RainDrop(T)
			new/obj/Supplemental/Weather/RainOver(T)
		if(T2)	if(!istype(T2,/turf/basic/grass) && !istype(T2,/turf/basic/Tree) && !istype(T2,/turf/Location))
			if(!istype(T2,/turf/City/Road) && !istype(T2,/turf/City/Side_Walk) && !istype(T2,/turf/Water))
				new/obj/Supplemental/Weather/RainDrop(T2)
				new/obj/Supplemental/Weather/RainOver(T2)

mob/HumanPlayer/verb
	Give_Val()
		set src in oview(8)
		var/Amt2Give=round(input("Give Val to [src]:","Give Val",0) as null|num)
		if(Amt2Give>usr.Val)	Amt2Give=usr.Val
		if(Amt2Give<=0)	return
		usr.Val-=Amt2Give;usr.ValHUD()
		src.Val+=Amt2Give;src.ValHUD()
		usr<<"You gave [Amt2Give] Val to [src]!"
		src<<"[usr] gave you [Amt2Give] Val!"
	Transport()
		set src in world
		usr<<sound('Chopper.ogg')
		usr.TeleportTo(src)

mob/proc/ActivateZombies()
	for(var/mob/Zombie/Z in oview(WorldView+1,src))
		if(!CheckMaxCPU())	break
		if(!Z.Hunting)	{Z.MobTarget=src;Z.Hunt()}

mob/var/obj/ChatBubble
obj/Supplemental
	ChatBubble
		icon='Emotes.dmi'
		pixel_x=20;pixel_y=20
		layer=MOB_LAYER+1;density=0

mob/Del()
	if(src.ChatBubble)	del src.ChatBubble
	if(src.AmmoBar)	del src.AmmoBar
	if(src.TeleBar)	del src.TeleBar
	if(src.HpBar)	del src.HpBar
	return ..()

mob/Player
	icon='Player.dmi'
	New()
		PlayerMobs+=src
		return ..()
	Del()
		PlayerMobs-=src
		return ..()
	Bump(var/obj/Barracades/O)
		if(src.client && istype(O,/obj/Barracades))
			if(!O.Secured)	if(step(O,src.dir))	flick("",src.ChatBubble)
		if(istype(O,/mob/Player))
			src.GenericLoc(O)
		return ..()

mob/proc/GenericLoc(var/atom/A)
	if(src.loc!=locate(A.x,A.y,A.z))
		src.loc.Exit(src)
		src.loc.Exited(src)
		src.loc=locate(A.x,A.y,A.z)
		src.loc.Enter(src)
		src.loc.Entered(src)
		src.Move()

mob/Login()
	src.LogClient()
	if(copytext(src.key,1,min(7,length(src.key)))=="Guest-" || src.key=="Guest")
		src<<"Guest Keys are Disabled.  You can create a Free Key at http://www.BYOND.com!"
		del src;return
	if(src.CheckGlobalBan())	{del src;return}
	src.SubCheck()
	if(Players.len>=PlayerLimit && src.key!=world.host)
		if(!src.Subscriber)
			src<<"[Players.len]/[PlayerLimit] Player Limit has been Reached.  Additional Slots Available for Subscribers"
			del src;return
	for(var/i=0;i<=9;i++)
		winset(src,"ID.Voice[i]", "parent=macro;name=[i]+UP;command='ProcessVoiceCmd [i]'")
	Players+=src
	src<<browse(Help)
	WorldStatusUpdate()
	winset(src,"SmallInfoWindow","size=308x160")
	winset(src,"MainWindow.MainMap","icon-size=32")
	winset(src,"MainWindow.GlobalChatBtn","is-checked=true")
	winset(src,"MainWindow.input1","text='Press Enter to Chat'")
	winset(src,"MainWindow","size=800x600;is-maximized=true;pos=0,0")
	src.verbs+=/mob/Player/PlayerOnly/verb/Follow_Player
	src.verbs+=/mob/Player/PlayerOnly/verb/Invite
	src.Ammos+=new/obj/AmmoTypes/Hand_Gun_Ammo
	src.Ammos+=new/obj/AmmoTypes/Shot_Gun_Ammo
	src.Ammos+=new/obj/AmmoTypes/Machine_Gun_Ammo
	src.Ammos+=new/obj/AmmoTypes/Sniper_Ammo
	src.Ammos+=new/obj/AmmoTypes/Rocket_Ammo
	src.BasicHUD()
	src.ChatBubble=new/obj/Supplemental/ChatBubble(src.loc)
	if(src.gender!="male")	src.HeadID="Female"
	if(src.gender!="male" && src.gender!="female")	src.HeadID="Pumpkin"
	if(src.Load())	world<<"<b><font color=black>[src] has Returned"
	else	world<<"<b><font color=black>[src] has Joined for the First Time"
	src.CanGetCashPoints=1
	src.CashPointPurchaseInfo()
	src.SaveMe=1
	src.DeathReset()
	src.Respec()
	spawn()	src.SecondLoop()
	spawn()	src.RefreshMiniMap()
	spawn()	src.AddMovementMacros()
	if(src.key==world.host || src.key=="Falacy")	src.verbs+=typesof(/mob/GM/verb)
	if(src.key=="Falacy")	src.verbs+=typesof(/mob/Test/verb)
	src.verbs+=typesof(/mob/HumanPlayer/verb)
	//src<<sound('FreakyZelda.mid')
	//spawn(400)	if(src)	src<<sound(null)

mob/Logout()
	Players-=src
	WorldStatusUpdate()
	if(src.Squad)	src.LeaveSquad()
	for(var/obj/Explosives/E in world)
		if(E.Owner==src)	del E
	src.ClassItemDelete()
	world<<"<b><font color=black>[src] Left"
	for(var/obj/Vehicles/V in world)	if(V.Owner==src)	VehicleExplode(V,V.TL.loc)
	for(var/obj/Portals/P in world)	if(P.Owner==src)	del P
	for(var/obj/O in src.DroppedItems)	if(O.DroppedBy==src)	del O
	if(src.FlashLightOn)	src.ToggleFlashLight()
	del src