var/TGO=new/obj/Supplemental/Overlays/ThermalGoggles
var/NVGO=new/obj/Supplemental/Overlays/NVG
obj/Supplemental
	Overlays
		icon='Overlays.dmi'
		layer=MOB_LAYER+1
		ThermalGoggles
			icon_state="Thermal"
		NVG
			icon_state="NVG"

obj/Supplemental
	Weather
		mouse_opacity=0
		icon='Effects.dmi'
		icon_state="invis"
		RainOver
			layer=MOB_LAYER+10
		RainDrop
			layer=OBJ_LAYER
obj
	Decoration
		icon='objects.dmi'
		Men
			icon_state="men"
		Women
			icon_state="women"
		Cash_Register
			icon='other.dmi';pixel_y=16
			icon_state="Cash Register"

obj/Other
	icon='objects.dmi'
	Respec_Point
		icon_state="RespecPoint"
		verb/UseRespec()
			set hidden=1
			usr.Respec()
	debris
		icon_state="debris"
		density=1
	fire
		icon_state="fire"
		density=1
	fountain
		icon='turfs.dmi'
		icon_state="fountb"
		density=1
	sink
		icon_state="sink"
		density=1
	Mall_Mart
		icon='other.dmi'
		icon_state="M"
		density=1
	Cross
		icon_state="Cross"
		density=1

obj/Objects
	icon='cityobjects.dmi'
	Radio
		density=1
		icon='Objects.dmi';icon_state="Radio"
		verb/Listen()
			set src in oview(1);usr<<"All you hear is static..."
	Microwave
		density=1
		icon='Objects.dmi';icon_state="Microwave"
		verb/Cook()
			set src in oview(1);usr<<"You don't have anything to Cook"
	Fridge
		density=1
		icon='Objects.dmi';icon_state="Fridge"
		verb/Storage()
			set src in oview(1);usr<<"You don't have any Food."
	Television
		density=1
		icon='Objects.dmi';icon_state="Tv"
		var/mob/Watcher
		verb/On()
			set src in oview(8)
			if(src.Watcher && get_dist(src,src.Watcher)<=WorldView && src.Watcher!=usr)
				usr<<"[src.Watcher] is watching that!";return
			src.Watcher=usr;src.icon_state="TvOn"
		verb/Off()
			set src in oview(8)
			if(src.Watcher && get_dist(src,src.Watcher)<=WorldView && src.Watcher!=usr)
				usr<<"[src.Watcher] is watching that!";return
			src.Watcher=null;src.icon_state="Tv"
		verb/News()
			set src in oview(8)
			if(src.Watcher && get_dist(src,src.Watcher)<=WorldView && src.Watcher!=usr)
				usr<<"[src.Watcher] is watching that!";return
			src.Watcher=usr;src.icon_state="TvNews"
	Lightable
		var/IsLit=0
		Lamp
			density=1
			icon='Interior.dmi';icon_state="Lamp"
		proc/LightSourceOff()
			for(var/obj/Supplemental/LightMap/L in view(WorldView,src))
				var/BrightenBy=round((10-get_dist(src,L))/2)
				L.Brightness-=BrightenBy;L.UpdateIS()
		proc/LightSourceOn()
			for(var/obj/Supplemental/LightMap/L in view(WorldView,src))
				var/BrightenBy=round((10-get_dist(src,L))/2)
				L.Brightness+=BrightenBy;L.UpdateIS()
		verb/ToggleLight()
			set hidden=1
			view(WorldView,src)<<sound('Click.ogg')
			if(!src.IsLit)
				src.IsLit=1;src.icon_state="Lit[src.name]"
				src.LightSourceOn()
			else
				src.IsLit=0;src.icon_state=src.name
				src.LightSourceOff()
	Desk
		density=1
		icon='Interior.dmi';icon_state="Desk"
	Table
		density=1
		icon='Interior.dmi';icon_state="Table"
	SmallTable
		density=1
		icon='Interior.dmi';icon_state="SmallTable"
	Chair
		icon='Interior.dmi';icon_state="ChairS"
		verb/Sit()
			set src in oview(0)
			usr.dir=src.dir
	Sleepable
		Bed
			density=1
			icon='Interior.dmi'
			icon_state="BedB"
		Couch
			icon_state="Couch1"
			verb/Sit()
				set src in oview(0)
				usr.dir=src.dir
		verb/Sleep()
			set src in oview(1)
			usr.icon_state="Sleep"
			usr.GenericLoc(src)
			usr.CanMove=0
			usr.dir=NORTH
		verb/Wake_Up()
			set src in oview(0)
			usr.icon_state=""
			usr.CanMove=1
			usr.dir=SOUTH
	Washable
		Tub
			density=1
			icon='Interior.dmi'
			icon_state="Tub"
		Sink
			icon_state="Full Sink"
			density=1
		verb/Wash()
			set src in oview(1)
	Clock
		density=1
		icon_state="Clock"
	Toilet
		icon_state="ToiletO"
		verb
			Use()
				set src in oview(0)
				usr.dir=SOUTH
				if(src.icon_state!="ToiletO")	src.icon_state="ToiletO"
			Lid()
				set src in oview(1)
				if(src.icon_state!="ToiletC")	src.icon_state="ToiletC"
				else	src.icon_state="ToiletO"