mob/Player
	icon='Player.dmi'
	SWAT_Trooper
		New()
			src.density=0
			src.HeadID=pick(HeadList-SpecialHeads)
			src.AddHead()
			src.VoiceSetText=pick(VoiceSetHolder.VoiceSets-"Zoey")
			if(src.HeadID in FemaleHeads)	src.VoiceSetText="Zoey"
			src.ApplyWeapon(pick("MachineGun","ShotGun","SniperRifle"))
			src.ChatBubble=new/obj/Supplemental/ChatBubble(src.loc)
			src.Skills+="Pyromaniac"
			src.Skills+="MacGyver"
			spawn(rand(25,35))	src.HuntZombies()
			return ..()
		Del()
			src.BackupMsg();return ..()
		proc/ApplyWeapon(var/WeaponType)
			src.Ammos=list()
			if(WeaponType=="HandGun")
				src.Weapon=new/obj/Guns/Hand_Guns/Revolver
				src.Ammos+=new/obj/AmmoTypes/Hand_Gun_Ammo
			if(WeaponType=="MachineGun")
				src.Weapon=new/obj/Guns/Machine_Guns/AK_47
				src.Ammos+=new/obj/AmmoTypes/Machine_Gun_Ammo
			if(WeaponType=="ShotGun")
				src.Weapon=new/obj/Guns/Shot_Guns/Pump_Action
				src.Ammos+=new/obj/AmmoTypes/Shot_Gun_Ammo
			if(WeaponType=="SniperRifle")
				src.Weapon=new/obj/Guns/Sniper_Rifles/Sighted_Rifle
				src.Ammos+=new/obj/AmmoTypes/Sniper_Ammo
			src.icon_state=src.Weapon.name
			src.contents+=src.Weapon
			src.Weapon.AmmoType=src.Ammos[1]

	proc/HuntZombies()
		if(src.Weapon.Ammo<=0 && src.Weapon.AmmoType.Ammo<=0)
			spawn()	src.KnifeHunt()
			return
		var/mint=30
		var/maxt=60
		for(var/mob/Zombie/M in oview(min(WorldView,usr.Weapon.Range)))
			if(rand(1,100)==1)	src.HighThrow()
			src.Fire()
			mint=src.Weapon.FireRate;maxt=src.Weapon.FireRate+1
			break
		for(var/obj/AmmoTypes/A in oview(1))	A.Get()
		for(var/obj/Corpse/C in oview(2))	C.BurnBody()
		for(var/obj/Barracades/B in oview(1))	if(B.HP<=0)	spawn()	B.RepairProc(src)
		spawn(rand(mint,maxt))	src.HuntZombies()

	proc/KnifeHunt()
		if(src.Weapon.Ammo>0)
			spawn()	src.HuntZombies()
			return
		var/mint=40
		var/maxt=50
		for(var/mob/Zombie/M in oview(1))
			if(rand(1,5)==1)	src.HighThrow()
			src.Knife()
			mint=5;maxt=6
			break
		for(var/obj/Corpse/C in oview(1))	C.BurnBody()
		for(var/obj/AmmoTypes/A in oview(1))	A.Get()
		for(var/obj/Barracades/B in oview(1))	if(B.HP<=0)	spawn()	B.RepairProc(src)
		spawn(rand(mint,maxt))	src.KnifeHunt()