mob/Test/verb
	TestLightCycle()
		set category="Test"
		var/list/DayParts=list()
		for(var/i=1;i<=5;i++)	DayParts+="Dawn [i]"
		for(var/i=1;i<=5;i++)	DayParts+="<b>Noon [i]"
		for(var/i=1;i<=5;i++)	DayParts+="Dusk [i]"
		for(var/i=1;i<=5;i++)	DayParts+="<b>Night [i]"
		LightCycle=input("Cycle Start","Input Light",LightCycle) as num
		src<<"This verb can screw things up!";return
		for(var/i=1,i<=20;i++)
			src<<"Part [DayParts[i]] : Light [LightCycle]"
			LightCycleProc()
	NightPointLinks()
		set category="Test"
		var/list/CommandPosts=list()
		for(var/obj/Command_Posts/CP_Spawner/P in world)	CommandPosts+=P
		NightPoint=pick(CommandPosts)
		src<<"The sun has begun to set...  <b>It looks like Zombies are amassing near the [cTeleLink(NightPoint)][NightPoint]</a>!  We should set up what defenses we can for tonight..."
	Capture_CPs()
		set category="Test"
		for(var/obj/Command_Posts/Command_Post/CP in world)	{CP.CapturedAmt=30;CaptureCP(CP,CarExploderMob)}
	Tele_Link()
		set category="Test"
		src<<"[cTeleLink(pick(world.contents))]Tele Link</a>"
	SnackBar()
		set category="Test"
		usr.contents+=new/obj/Edible/Meal
	DownMe()
		set category="Test"
		usr.DownPlayer()
	EmptyAmmoStock()
		set category="Test"
		if(src.Weapon && src.Weapon.AmmoType)	src.Weapon.AmmoType.Ammo=1
	Reload1Ogg()
		set category="Test"
		usr<<sound('reload1.ogg')
	CheckCPs()
		set category="Test"
		for(var/obj/Command_Posts/CP_Spawner/P in world)	src<<P
	LevelUp()
		set category="Test"
		usr.Exp=usr.Level*100
		usr.LevelCheck()
	FindSecured()
		set category="Test"
		var/counter=0
		for(var/obj/Barracades/B in world)
			if(B.secured)
				counter+=1
				src<<"[B.x],[B.y],[B.z]"
		src<<"Found: [counter]"
	CountSpawnLocs()
		set category="Test"
		for(var/obj/Command_Posts/CP_Spawner/P in world)
			NightPoint=P
			var/list/SpawnLocs=list();for(var/obj/Supplemental/SpawnLoc/L in world)	if(L.name==NightPoint.name)	SpawnLocs+=L
			src<<"[NightPoint]: [SpawnLocs.len] Enemy Spawn Locs ([NightPoint.SpawnPoints.len])"
	CheckIP(var/mob/M in world)
		set category="Test"
		if(M.client)	usr<<"[M.key]	<b>[M.client.computer_id]</b>	[M.client.address]"
	IronMan()
		set category="Test"
		usr.icon='IronMan.dmi'
		usr.HeadID="Full_Ironman"
		var/obj/O=new/obj/Guns/Hidden/Repulsor
		usr.contents+=O
		O.Click()
		usr.contents-=O
		usr.AddHead()
	CheckNullObjects()
		set category="Test"
		set background=1
		var/counter=0
		var/list/NameList=list()
		for(var/obj/O in world)	if(O.name=="obj")
			counter+=1
			if(!("[O.icon]" in NameList))	NameList+="[O.icon]"
			NameList["[O.icon]"]+=1
		for(var/x in NameList)
			usr<<"[NameList[x]]	| [x] Objs"
		usr<<"<b>     Total: [counter]"
	CheckCPU()
		set category="Test"
		usr<<"Highest CPU: [HighestCPU]% | Highest Players: [HighestPlayers]"
		usr<<"100% Usage Ticks: [TicksOver100] | Total Ticks: [TotalTicks]"
		usr<<"<b>Average CPU:</b> [round(TotalCPU/TotalTicks)]% | <b>Average Players:</b> [round(TotalPlayers/TotalTicks)]"
		usr<<"<b>Average 100% Ticks:</b> [round(TicksOver100/TotalTicks*100)]%"
	CheckOverlays()
		set category="Test"
		var/counter=0
		for(var/atom/A in world)
			counter+=A.overlays.len
		usr<<counter
	CheckZombies()
		set category="Test"
		set background=1
		var/Total=0
		var/Actives=0
		var/WithTargets=0
		var/WithObjsOnly=0
		for(var/mob/Zombie/Z in world)
			Total+=1
			if(Z.Hunting)	Actives+=1
			if(Z.MobTarget)	WithTargets+=1
			if(Z.ObjTarget && !Z.MobTarget)	WithObjsOnly+=1
		usr<<"Total Zombies: [Total]"
		usr<<"Active Zombies: [Actives]"
		usr<<"With Mob Targets: [WithTargets]"
		usr<<"With Object Targets Only: [WithObjsOnly]"
	CheckMobs()
		set category="Test"
		set background=1
		var/counter=0
		var/list/NameList=list()
		for(var/mob/O in world)
			counter+=1
			if(!(O.name in NameList))	NameList+=O.name
		for(var/x in NameList)
			var/NameCount=0
			for(var/mob/O in world)
				if(O.name==x)	NameCount+=1
			var/datum/mobCounter/D
			for(var/datum/mobCounter/O in mobCounters)
				if(O.name==x)	D=O
			if(!D)	D=new/datum/mobCounter
			mobCounters+=D
			if(NameCount!=D.LastCount)
				if(NameCount>=100)	usr<<"<font color=red>[x] [NameCount] / [D.LastCount]"
				else	usr<<"[x] [NameCount] / [D.LastCount]"
			D.name=x;D.LastCount=NameCount
		usr<<"<b>     Total: [counter]"
	CheckObjects()
		set category="Test"
		set background=1
		var/counter=0
		var/list/NameList=list()
		for(var/obj/O in world)
			counter+=1
			if(!(O.name in NameList))	NameList+=O.name
		for(var/x in NameList)
			var/NameCount=0
			for(var/obj/O in world)
				if(O.name==x)	NameCount+=1
			var/datum/ObjCounter/D
			for(var/datum/ObjCounter/O in ObjCounters)
				if(O.name==x)	D=O
			if(!D)	D=new/datum/ObjCounter
			ObjCounters+=D
			if(NameCount!=D.LastCount)
				if(NameCount>=100)	usr<<"<font color=red>[x] [NameCount] / [D.LastCount]"
				else	usr<<"[x] [NameCount] / [D.LastCount]"
			D.name=x;D.LastCount=NameCount
		usr<<"<b>     Total: [counter]"