mob/Topic(href,href_list[])
	var/list/Params=params2list(href)
	switch(Params["Action"])
		if("TeleLink")
			var/atom/TeleportTo=locate(Params["TeleportTo"])
			if(TeleportTo)	//use usr since this is in global chat
				usr<<sound('Chopper.ogg')
				usr.TeleportTo(TeleportTo)
				winset(usr,"MainWindow.MainMap","focus=true")


	var/section=href_list["sec"]
	var/Links={"<a href='?src=\ref[usr];sec=[section];action=B2S'>Back To Shop</a><br>
			<a href='?src=\ref[usr];sec=[section];action=Close'>Close</a>"}

	usr<<browse(null,"window=Notice")
	usr<<browse(null,"window=Upgrade")
	usr<<browse(null,"window=Choose")
	if(href_list["action"]=="Close")	return
	if(href_list["action"]=="Cancel")	return
	if(href_list["action"]=="Choose")
		usr.Chosen=locate(href_list["Chosen"]);return
	switch(href_list["sec"])
		if("Storage")
			for(var/mob/Player/Jobs/Storage_Service/M in oview(WorldView,usr))
				var/obj/O=locate(href_list["item"])
				switch(href_list["action"])
					if("Purchase")
						if(usr.Val>=1000)
							usr.Val-=1000;usr.StorageSize+=1
							usr.ValHUD()
						else
							usr.PlayMerchant('NotEnoughCash.ogg');return
					if("Store")
						if(O in usr.contents)
							if(usr.Storage.len<usr.StorageSize)
								usr.contents-=O;usr.Storage+=O
								if(O.suffix=="Equipped")
									O.suffix=null;usr.Weapon=null
									usr.ResetIS();usr.EquipHUD()
							else	usr<<"Storage Full"
					if("Take")
						if(O in usr.Storage)
							if(usr.contents.len<usr.PackSize)
								usr.Storage-=O;usr.contents+=O
							else	usr<<"Inventory Full"
				usr.ItemHUD()
				usr.StorageShop()
				usr.PlayMerchant(list('ThankYou.ogg','IsThatAll.ogg'))
				return
			usr<<browse(null,"window=Storage")
		if("Shop")
			usr<<browse(null,"window=Shop")
			switch(href_list["action"])
				if("B2S")
					usr.ShopProc(usr.ShopItems)
				if("Buy")
					var/obj/Items/I=locate(href_list["item"])
					if(usr.contents.len<usr.PackSize)
						if(usr.vars[usr.ShoppingWith]>=I.Price)
							var/obj/NewI=new I.type(usr)
							usr.vars[usr.ShoppingWith]-=I.Price
							if(usr.ShoppingWith=="CashPoints")	NewI.CashPointed=1
							usr.ValHUD();usr.ItemHUD()
							goto PurchaseThanks
						else
							goto NotEnoughVal
		if("Upgrade")
			usr<<browse(null,"window=Upgrade")
			switch(href_list["action"])
				if("B2S")
					usr.UpgradeShop();return
				else
					var/ThisStat=href_list["action"]
					var/obj/Guns/G=locate(href_list["gun"])
					var/MaxLevel=abs((initial(G.vars["[ThisStat]"])-G.vars["Max[ThisStat]Level"])/G.vars["[ThisStat]LevelUp"])
					MaxLevel=min(99,MaxLevel)
					if(G.vars["[ThisStat]Level"]>=MaxLevel)	goto UpgradeError
					if(usr.vars[usr.ShoppingWith]>=(G.vars["[ThisStat]Level"]+1)*150)
						if(usr.ShoppingWith=="CashPoints")	G.CashPointed=1
						usr.vars[usr.ShoppingWith]-=(G.vars["[ThisStat]Level"]+1)*150//takes the val
						usr.ValHUD()
						G.vars["[ThisStat]Level"]+=1//adds to the level
						var/Multi=1
						if(ThisStat=="FireRate" || ThisStat=="ReloadTime")	Multi=-1
						if(ThisStat=="Ammo")
							G.MaxAmmo+=G.vars["[ThisStat]LevelUp"]//adds to the stat
							if(G.vars["Max[ThisStat]"]>G.vars["Max[ThisStat]Level"])	G.vars["Max[ThisStat]"]=G.vars["Max[ThisStat]Level"]
							G.Ammo=G.MaxAmmo;usr.AmmoHUD()
						else	G.vars["[ThisStat]"]+=G.vars["[ThisStat]LevelUp"]*Multi//adds to the stat
						if(Multi==(-1))	if(G.vars["[ThisStat]"]<G.vars["Max[ThisStat]Level"])	G.vars["[ThisStat]"]=G.vars["Max[ThisStat]Level"]
						else	if(G.vars["[ThisStat]"]>G.vars["Max[ThisStat]Level"])	G.vars["[ThisStat]"]=G.vars["Max[ThisStat]Level"]
						goto UpgradeComplete
					else	goto NotEnoughVal
	return

	PurchaseThanks
	usr.PlayMerchant(list('ThankYou.ogg','IsThatAll.ogg'))
	usr<<browse({"<center><body bgcolor=gray>
			Thanks for the Business<br>Come back Anytime.<p>[Links]
		"},"window=Notice")
	return

	UpgradeError
	usr<<browse({"<center><body bgcolor=gray>
			Weapon Cannot be Upgraded Beyond This Point<p>[Links]
		"},"window=Notice")
	return

	NotEnoughVal
	usr.PlayMerchant('NotEnoughCash.ogg')
	usr<<browse({"<center><body bgcolor=gray>
			You dont have enough [usr.ShoppingWith]!<p>[Links]
		"},"window=Notice")
	return

	UpgradeComplete
	usr.PlayMerchant(list('ThankYou.ogg','IsThatAll.ogg'))
	usr<<browse({"<center><body bgcolor=gray>
			Weapon Upgrade Complete<p>[Links]
		"},"window=Notice")
	return