mob/var/obj/VehiclePart/Vehicle
mob/var/Seat
mob/Move(var/turf/NewLoc,var/NewDir)
	if(src.Vehicle)
		if(src.RcD)	return ..()
		if(src.Seat!="Drivers Seat")	return
		if(src.Vehicle.Vehicle.Owner && src.Vehicle.Vehicle.Owner!=src)
			src<<"You don't have the keys for this Vehicle!";return
		src.ActivateZombies()
		if(!src || !src.Vehicle)	return
		src.dir=NewDir
		var/turf/T1
		var/obj/Vehicles/Vehicle2use=src.Vehicle.Vehicle
		if(NewDir==NORTH)	{src.loc=Vehicle2use.TL.loc ; T1=get_step(Vehicle2use.TR,NewDir)}
		if(NewDir==SOUTH)	{src.loc=Vehicle2use.BR.loc ; T1=get_step(Vehicle2use.BL,NewDir)}
		if(NewDir==EAST)	{src.loc=Vehicle2use.TR.loc ; T1=get_step(Vehicle2use.BR,NewDir)}
		if(NewDir==WEST)	{src.loc=Vehicle2use.BL.loc ; T1=get_step(Vehicle2use.TL,NewDir)}
		var/turf/T=get_step(src,NewDir)
		if(!T || !T1)	return
		CarKillZombie(T)
		CarKillZombie(T1)
		BreakWindowsInLocation(T);BreakWindowsInLocation(T1)
		var/list/listo=list(Vehicle2use.TL,Vehicle2use.TR,Vehicle2use.BL,Vehicle2use.BR)
		for(var/obj/VehiclePart/O in listo)
			O.dir=NewDir
			if(O.Passanger)	O.Passanger.dir=O.dir
		src.loc=src.Vehicle.loc
		src.Move()
		if(!T.Enter(src))	return
		if(!T1.Enter(src))	return
		for(var/obj/VehiclePart/O in listo)
			if(NewDir==NORTH)	{O.dir=NewDir;O.y+=1}
			if(NewDir==SOUTH)	{O.dir=NewDir;O.y-=1}
			if(NewDir==EAST)	{O.dir=NewDir;O.x+=1}
			if(NewDir==WEST)	{O.dir=NewDir;O.x-=1}
			if(O.Passanger)
				O.Passanger.dir=O.dir;O.Passanger.loc=O.loc
				O.Passanger.Move()
		return
	return ..()

proc/CarKillZombie(var/turf/NewLoc)
	if(!DayTime)	return
	for(var/mob/Zombie/Z in NewLoc)
		ZombiesKilled+=1
		var/obj/NC=new/obj/Corpse(Z,Z.BodyNum,Z.HeadIcon,Z.HeadNum)
		spawn(1)	step_away(NC,src)
		del Z;break

proc/BreakWindowsInLocation(var/turf/T)
	for(var/obj/TurfType/Window/W in T)
		W.HP=0;W.BreakWindow()

obj/Vehicles
	density=0
	HP=250
	var/mob/Owner
	var/list/Parts=list()
	var/obj/VehiclePart/TL
	var/obj/VehiclePart/BL
	var/obj/VehiclePart/BR
	var/obj/VehiclePart/TR
	New()
		src.icon_state="invis"
		new/obj/VehiclePart(src,"TL")
		new/obj/VehiclePart(src,"BR")
		new/obj/VehiclePart(src,"TR")
		new/obj/VehiclePart(src,"BL")
	Jeep
		icon='jeep.dmi'

obj/VehiclePart
	density=1
	name="Passangers Seat"
	var/mob/Passanger
	var/obj/Vehicles/Vehicle
	New(var/obj/Vehicles/V,var/Spot)
		src.icon=V.icon;src.dir=V.dir
		V.Parts+=src;src.Vehicle=V
		if(Spot=="TL")
			src.name="Drivers Seat"
			V.TL=src;src.loc=locate(V.x,V.y,V.z)
		if(Spot=="BR")
			V.BR=src;src.loc=locate(V.x+1,V.y-1,V.z)
			src.pixel_x=32;src.pixel_y=-32
		if(Spot=="TR")
			V.TR=src;src.loc=locate(V.x+1,V.y,V.z)
			src.pixel_x=32
		if(Spot=="BL")
			V.BL=src;src.loc=locate(V.x,V.y-1,V.z)
			src.pixel_y=-32
		src.icon_state=Spot;src.layer=OBJ_LAYER
		V.TL.overlays+=src;src.icon_state="invis"
	verb/Get_In()
		set hidden=1
		set src in oview(1)
		if(!usr.CanMove)	return
		if(usr.Vehicle)	{usr<<"You are already in a Vehicle!";return}
		if(src.Passanger)	{usr<<"Occupied";return}
		if(src.Vehicle.Owner)	usr<<"Welcome to [src.Vehicle.Owner]'s vehicular transportation!"
		if(!src.Vehicle.TL.Passanger && src.name!="Drivers Seat")	usr<<"This Vehicle has no Driver! Use the Top Left Seat to Drive."
		walk(usr,0)
		flick("",usr.ChatBubble)
		usr.Vehicle=src
		usr.MovementSpeed=1
		usr.Seat=src.name
		usr.dir=src.dir
		usr.GenericLoc(src)
		usr.icon_state="In Car"
		src.Passanger=usr
	verb/Get_Out()
		set hidden=1
		set src in oview(0)
		if(src.Passanger==usr)
			usr.Vehicle=null
			usr.MovementSpeed=2
			usr.ResetIS()
			src.Passanger=null