mob/proc/DisplayActions(var/turf/ActionTurf,var/turf/MyTurf)
	if(!src.client)	return
	if(!ActionTurf)	ActionTurf=get_step(src,src.dir)
	if(!MyTurf)	MyTurf=src.loc
	if(ActionTurf)
		if(src.Vehicle)	{src.UpdateHUDText("ActionMsg","E : Exit Vehicle");return}
		for(var/obj/Other/Respec_Point/R in MyTurf)	{src.UpdateHUDText("ActionMsg","E : Talent Screen");return}
		for(var/obj/Objects/Lightable/L in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Power [L]");return}
		for(var/obj/Corpse/C in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Burn Corpse");return}
		for(var/obj/AmmoTypes/A in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Take [A]");return}
		for(var/obj/Edible/A in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Take [A]");return}
		for(var/obj/Guns/G in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Take [G]");return}
		for(var/obj/Items/I in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Take [I]");return}
		for(var/obj/SpecialItems/I in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Take [I]");return}
		for(var/obj/Barracades/B in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Jump [B]");return}
		for(var/obj/Supplemental/Switch/S in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Activate [S]");return}
		for(var/obj/TurfType/Door/D in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Open/Close [D]");return}
		for(var/obj/VehiclePart/V in ActionTurf)	{src.UpdateHUDText("ActionMsg","E : Enter Vehicle");return}
		for(var/obj/Portals/P in MyTurf)	{src.UpdateHUDText("ActionMsg","E : Enter Portal");return}
	src.UpdateHUDText("ActionMsg","")

mob/verb/ProcessActions()
	set hidden=1
	if(src.Vehicle)	{src.Get();return}
	var/turf/ActionTurf=get_step(src,src.dir)
	for(var/obj/Other/Respec_Point/R in src.loc)	{R.UseRespec();return}
	for(var/obj/Objects/Lightable/L in ActionTurf)	{L.ToggleLight();return}
	for(var/obj/Corpse/C in ActionTurf)	{src.BurnBodies();return}
	for(var/obj/AmmoTypes/A in ActionTurf)	{A.Get();return}
	for(var/obj/Edible/A in ActionTurf)	{A.Get();return}
	for(var/obj/Guns/G in ActionTurf)	{G.Get();return}
	for(var/obj/Items/I in ActionTurf)	{I.Get();return}
	for(var/obj/SpecialItems/I in ActionTurf)	{I.Get();return}
	for(var/obj/Barracades/B in ActionTurf)	{src.JumpOn();return}
	for(var/obj/TurfType/Door/D in ActionTurf)	{src.Open();return}
	for(var/obj/Supplemental/Switch/S in ActionTurf)	{S.Activate();return}
	for(var/obj/VehiclePart/V in ActionTurf)	{src.JumpOn();return}
	for(var/obj/Portals/P in src.loc)	{P.UsePortal();return}