mob/Player
	Command_Post
		density=0
		icon='other.dmi'
		icon_state="Captured Flag"
	Recap_Post
		density=0
		icon='other.dmi'
		icon_state="Recap Flag"
		var/CapturedAmt=0
		var/mob/CapturedBy

obj/Command_Posts
	icon='other.dmi'
	Capture_Percent
		icon_state="Captured"

	Civilian_Spawner
		icon_state="Civ"
		New()
			src.icon_state="invis";return ..()
	Troop_Spawner
		icon_state="Trp"
		var/mob/Player/MyTroop
		New()
			src.icon_state="invis";return ..()
	Barracade_Spawner
		icon_state="Bar"
		var/obj/Barracades/MyBarricade
		New()
			src.icon_state="invis";return ..()

	CP_Spawner
		var/list/SpawnPoints=list()
		icon_state="CP"
		verb/Transport()
			set src in world
			usr<<sound('Chopper.ogg')
			usr.TeleportTo(src)
		New()
			spawn(1)	for(var/obj/Supplemental/SpawnLoc/L in world)	if(L.name==src.name)	src.SpawnPoints+=L
			src.icon=null;return ..()
	Command_Post
		icon_state="Flag"
		var/CapturedAmt=0
		var/mob/CapturedBy

proc/CaptureCP(var/mob/Player/Recap_Post/CP,var/mob/ForceCap)
	if(!CP)	return
	var/list/CapList=list()
	for(var/mob/Player/M in oview(1,CP))	if(M.client)
		if(CP.CapturedBy)	if(get_dist(CP,CP.CapturedBy)>1)	CP.CapturedBy=null
		if(!CP.CapturedBy)	CP.CapturedBy=M
		CapList+=M;CP.CapturedAmt+=1
	if(ForceCap)	CP.CapturedBy=ForceCap
	if(CapList.len || ForceCap)
		if(CP.CapturedAmt>=30)
			view(WorldView,CP)<<sound('reload.ogg')
			var/mob/Player/Command_Post/NCP=new(CP.loc)
			NCP.name=CP.name
			for(var/mob/Player/P in oview(WorldView,CP))	P.FullReSupply()
			for(var/obj/Command_Posts/Troop_Spawner/T in oview(WorldView,CP))
				if(!T.MyTroop)	T.MyTroop=new/mob/Player/SWAT_Trooper(T.loc)
			for(var/obj/TurfType/T in oview(WorldView,CP))
				if(T.HP<=0)	T.FinishRepair()
				else	T.HP=T.MaxHP
			for(var/obj/Barracades/B in oview(WorldView,CP))
				if(B.HP<=0)	B.FinishRepair()
				else	B.HP=B.MaxHP
			for(var/obj/Command_Posts/Barracade_Spawner/T in oview(WorldView,CP))
				if(!T.MyBarricade)
					var/obj/Barracades/Military_Barracade/B=new(T.loc)
					B.Secure();T.MyBarricade=B
			CP.CapturedBy.GiveVal(10)
			var/FntG="<font color=gray>"
			if(istype(CP,/mob/Player/Recap_Post))	oview(WorldView,CP)<<"<b>[FntG][CP.CapturedBy] Has <font color=white>ReCaptured[FntG] the [CP.name] at [CP.x], [CP.y]!"
			else	world<<"<b>[FntG][CP.CapturedBy] Has <font color=white>Captured[FntG] the [CP.name] at [CP.x], [CP.y]!"
			for(var/obj/Command_Posts/CP_Spawner/CPS in world)	if(CPS.name==CP.name)
				if(!(CPS in CapturedCPs))
					CapturedCPs+=CPS;UnCapturedCPs-=CPS
				for(var/obj/Job_Spawner/J in world)	if(!J.invisibility && J.RequiredCP==CP.name)
					J.invisibility=101
					var/pathy=text2path("[J.JobType]")
					J.JobMob=new pathy(J.loc)
					//world<<"<b><font color=white>A new [J.name] has been Setup at [J.x], [J.y]!"
			for(var/mob/M in oview(1,CP)-CP.CapturedBy)
				M.GiveVal(5)
				M<<"<font color=gray>Received Capture Assist Val..."
			del CP;return
		CP.UpdateCapBar(CP.CapturedAmt)
	if(CapList.len<=0)
		if(CP)	{CP.CapturedAmt=0;CP.CapturedBy=null;CP.overlays=list()}
		return
	spawn(5)	CaptureCP(CP)