obj/ShopItems
	Recon_Remote
		Price=5000
		icon_state="ReconRemote"
		Drop()
			if(usr.RcD)	del usr.RcD
			usr.GenericDrop(src)
		verb/Activate()
			set src in usr
			if(usr.CanAct && usr.client.eye==usr)
				usr.RcD("Recon")
		verb/Disengage()
			set src in usr
			if(usr.RcD)	del usr.RcD
	Chopper_Remote
		Price=15000
		icon_state="ChopperRemote"
		Drop()
			if(usr.RcD)	del usr.RcD
			usr.GenericDrop(src)
		verb/Activate()
			set src in usr
			if(usr.CanAct && usr.client.eye==usr)
				usr.RcD("Chopper")
		verb/Disengage()
			set src in usr
			if(usr.RcD)	del usr.RcD

mob/proc/RcD(var/RcDType)
	if(usr.RcD)	return
	if(!usr.CanAct)	return
	var/NewType=text2path("/mob/Player/Drones/[RcDType]")
	usr.RcD=new NewType(usr)
	if(usr.RcD.MoveSound)	usr<<sound(usr.RcD.MoveSound,repeat=1,channel=5)
	usr.client.eye=usr.RcD
	usr.dir=SOUTH
	usr.CanAct=0
	usr.icon_state="RC"

mob/var/mob/Player/Drones/RcD

mob/Player/Drones
	icon='Drones.dmi'
	density=1
	var/MoveSound
	var/Armed=1
	Recon
		icon_state="Recon"
		Armed=0
		Move(NewLoc,NewDir)
			CarKillZombie(NewLoc)
			return ..()
	Turret
		icon_state="Turret"
		New(var/mob/M)
			..(M)
			spawn()	src.TurretHunt()
	Rocket_Turret
		Armed=2
		icon_state="Rocket Turret"
		New(var/mob/M)
			..(M)
			spawn()	src.TurretHunt()
	Chopper
		MoveSound='Chopper.ogg'
		icon_state="Chopper"
		density=0
		layer=10
	Move()
		src.ActivateZombies()
		return ..()
	proc/TurretHunt()
		var/MinWait=30;var/MaxWait=60;sleep(rand(MinWait,MaxWait))
		if(!src.Owner)	{del src;return}
		if(src.Weapon.Ammo<=0 && src.Weapon.AmmoType.Ammo<=0)	{del src;return}
		for(var/mob/Zombie/M in oview(usr.Weapon.Range))
			MinWait=src.Weapon.FireRate;MaxWait=src.Weapon.FireRate+1
			src.Fire();break
		spawn(rand(MinWait,MaxWait))	src.TurretHunt()
	New(var/mob/M)
		src.Owner=M
		src.loc=M.loc
		src.dir=M.dir
		src.AddName(M.name)
		if(src.Armed)
			if(src.Armed==1)
				src.Weapon=new/obj/Guns/Machine_Guns/Machine_Gun
				src.Weapon.FireRate=2
				src.Weapon.FirePower=5
				src.Ammos+=new/obj/AmmoTypes/Machine_Gun_Ammo
				src.Weapon.AmmoType=src.Ammos[1]
			if(src.Armed==2)
				src.Weapon=new/obj/Guns/Special/Rocket_Launcher
				src.Weapon.FireRate=10
				src.Weapon.FirePower=100
				src.Ammos+=new/obj/AmmoTypes/Rocket_Ammo
				src.Weapon.AmmoType=src.Ammos[1]
			src.Weapon.name=src.name
			src.contents+=src.Weapon
			src.Weapon.Ammo=999999999
		return ..()
	Del()
		if(src.Owner)
			src.Owner.CanAct=1
			src.Owner.ResetIS()
			src.Owner<<sound(null,channel=5)
			ShowExplosion(src.loc)
			if(src.Owner.client)	src.Owner.client.eye=src.Owner
		return ..()