obj/Guns
	icon='guns.dmi'
	var/Level=1
	var/Exp=0
	var/Price=1
	var/FireRate=4
	var/ReloadTime=20
	var/Ammo=9
	var/MaxAmmo=9
	var/FirePower=3
	var/ProfBoostSkill="Not Available"
	var/AmmoTypeName="Hand Gun Ammo"
	var/obj/AmmoTypes/AmmoType
	var/Proficiency=3
	var/Radial=1
	var/Range=8
	var/firesound='gunshot1.ogg'

	//the below set of variables are for weapon upgrading
	var/FireRateLevel=0//How Fast you Fire
	var/FireRateLevelUp=0.5
	var/MaxFireRateLevel=8
	var/ReloadTimeLevel=0//How Fast you Reload
	var/ReloadTimeLevelUp=1
	var/MaxReloadTimeLevel=8
	var/FirePowerLevel=0//How Much Damage you Deal
	var/FirePowerLevelUp=1
	var/MaxFirePowerLevel=7
	var/ProficiencyLevel=0//Head Shot %
	var/ProficiencyLevelUp=1
	var/MaxProficiencyLevel=7
	var/AmmoLevel=0//Ammo Per Clip
	var/AmmoLevelUp=1
	var/MaxAmmoLevel=6

	mouse_opacity=2
	Get()
		usr.GenericGet(src)
	verb/Drop()
		usr.GenericDrop(src)
	verb/Check()
		set src in usr.contents
		usr<<browse({"<html>
		<body bgcolor=gray>
		<center>
		<body scroll=no>
		<table border=1 bgcolor=gray>
		<tr><td colspan=2><center>[src.name]<br>
			Level: [src.Level] -:- [src.Exp] / [src.Level*100] Exp
		<tr><td><b>Category<td><b>Cur / Max Stat
		<tr><td>Fire Power<td>[src.FirePower] / [src.MaxFirePowerLevel] Damage
		<tr><td>Fire Rate<td>[src.FireRate] / [src.MaxFireRateLevel] Delay
		<tr><td>Reload Time<td>[src.ReloadTime] / [src.MaxReloadTimeLevel] Delay
		<tr><td>Max Ammo<td>[src.MaxAmmo] / [src.MaxAmmoLevel] Ammo
		<tr><td>Proficiency<td>[src.Proficiency] / [src.MaxProficiencyLevel] %
		<tr><td>Ammo Type<td>[src.AmmoTypeName]
		"},"window=GUN;size=300x350")
	Click(var/mob/M)
		if(ismob(M))	usr=M
		if(src in usr.contents)
			usr<<sound('reload.ogg')
			if(src.suffix=="Equipped")
				src.suffix=null;usr.Weapon=null
				usr.ResetIS()
			else
				if(usr.Weapon)	usr.Weapon.suffix=null
				src.suffix="Equipped"
				usr.Weapon=src
				usr.ResetIS()
				for(var/obj/AmmoTypes/O in usr.Ammos)
					if(O.name==src.AmmoTypeName)
						src.AmmoType=O;break
			usr.EquipHUD()
			spawn()	if(usr && usr.Weapon && usr.Weapon.Ammo<=0)	usr.Reload()
		else	src.Get()

	Hand_Guns
		Price=150
		Proficiency=5
		ProfBoostSkill="Hand Gun Proficiency"
		AmmoTypeName="Hand Gun Ammo"
		MaxFireRateLevel=3
		MaxReloadTimeLevel=10
		MaxFirePowerLevel=25
		FirePowerLevelUp=3
		ProficiencyLevelUp=5
		MaxProficiencyLevel=45
		MaxAmmoLevel=15
		Beretta
			icon_state="Beretta"
			FireRate=4
			ReloadTime=20
			Ammo=9
			MaxAmmo=9
			FirePower=4
		Pistol
			icon_state="Pistol"
			FireRate=4
			ReloadTime=20
			Ammo=12
			MaxAmmo=12
			FirePower=3
		Silenced_PP7
			icon_state="Silenced PP7"
			FireRate=3
			ReloadTime=15
			Ammo=7
			MaxAmmo=7
			FirePower=3
			firesound='ric1.ogg'
		Revolver
			icon_state="Revolver"
			FireRate=6
			ReloadTime=25
			Ammo=6
			MaxAmmo=6
			FirePower=8
		Automatic_Hand_Gun
			//Was an Automatic
			Price=300
			icon_state="Automatic Hand Gun"
			FireRate=2
			ReloadTime=15
			Ammo=45
			MaxAmmo=45
			MaxAmmoLevel=50
			FirePower=1

	Automatics
		Proficiency=2	//Old Automatic Settings
		firesound='automatic.ogg'
		MaxFireRateLevel=1
		MaxReloadTimeLevel=5
		MaxFirePowerLevel=6
		MaxProficiencyLevel=10
		MaxAmmoLevel=50
		AmmoLevelUp=2
		New()
			spawn(1)	del src
		Automatic_Hand_Gun
		Uzi

	Machine_Guns
		Proficiency=1
		ProfBoostSkill="Machine Gun Proficiency"
		AmmoTypeName="Machine Gun Ammo"
		firesound='MachineGun.ogg'
		MaxFireRateLevel=1
		MaxReloadTimeLevel=10
		MaxFirePowerLevel=25
		FirePowerLevelUp=2
		MaxProficiencyLevel=5
		MaxAmmoLevel=75
		AmmoLevelUp=2
		Uzi
			//Was an Automatic
			Price=350
			icon_state="Uzi"
			FireRate=2
			ReloadTime=10
			Ammo=25
			MaxAmmo=25
			FirePower=3
		Machine_Gun
			Price=400
			icon_state="Machine Gun"
			FireRate=2
			ReloadTime=25
			Ammo=45
			MaxAmmo=45
			FirePower=5
		AK_47
			Price=450
			icon_state="AK 47"
			FireRate=2
			ReloadTime=30
			Ammo=50
			MaxAmmo=50
			FirePower=7

	Shot_Guns
		Proficiency=10
		Radial=3
		Range=4
		ProfBoostSkill="Shot Gun Proficiency"
		AmmoTypeName="Shot Gun Ammo"
		firesound='shotgun25.ogg'
		MaxFireRateLevel=8
		MaxReloadTimeLevel=10
		MaxFirePowerLevel=50
		MaxProficiencyLevel=25
		MaxAmmoLevel=12
		FirePowerLevelUp=5
		FireRateLevelUp=1
		Pump_Action
			Price=500
			icon_state="Pump Action"
			FireRate=25
			ReloadTime=25
			Ammo=4
			MaxAmmo=4
			FirePower=50

		Twelve_Guage
			Price=550
			name="12 Gauge"
			icon_state="12 Gauge"
			FireRate=20
			ReloadTime=20
			Ammo=6
			MaxAmmo=6
			FirePower=25

	Sniper_Rifles
		Proficiency=100
		Range=15
		AmmoTypeName="Sniper Ammo"
		firesound='SniperRifle.ogg'
		MaxFireRateLevel=10
		MaxReloadTimeLevel=15
		MaxFirePowerLevel=150
		MaxProficiencyLevel=100
		MaxAmmoLevel=6
		FirePowerLevelUp=5
		Sighted_Rifle
			Price=600
			icon_state="Sighted Rifle"
			FireRate=20
			ReloadTime=30
			Range=15
			Ammo=1
			MaxAmmo=1
			FirePower=75
			AmmoTypeName="Sniper Ammo"

	Special
		Rocket_Launcher
			Price=150000
			AmmoTypeName="Rocket Ammo"
			icon_state="Rocket Launcher"
			FireRate=50
			ReloadTime=70
			Ammo=1
			MaxAmmo=1
			FirePower=100
			Proficiency=0

			MaxFireRateLevel=30
			MaxReloadTimeLevel=50
			MaxFirePowerLevel=100
			MaxProficiencyLevel=0
			MaxAmmoLevel=2
	Hidden
		Repulsor
			AmmoTypeName="Rocket Ammo"
			firesound='Laser.ogg'
			icon_state=""
			FireRate=5
			ReloadTime=5
			Ammo=99
			MaxAmmo=99
			FirePower=100
			Proficiency=100

			MaxFireRateLevel=5
			MaxReloadTimeLevel=10
			MaxFirePowerLevel=100
			MaxProficiencyLevel=100
			MaxAmmoLevel=99

obj/AmmoTypes
	var/Ammo=100
	var/MaxAmmo=100
	var/DeleteMe=1
	icon='ammo.dmi'
	New(var/Loc,var/DelMe=1)
		src.loc=Loc;src.DeleteMe=DelMe
		if(src.DeleteMe)	spawn(1200)	if(src.loc)	del src
	mouse_opacity=2
	Get()
		if(get_dist(usr,src)>1)	return
		if(src.name=="Grenade")
			var/MaxGrenades=3
			if("Grenades" in usr.Skills)	MaxGrenades=5
			if(usr.Grenades<MaxGrenades)
				usr<<sound('reload.ogg')
				usr.Grenades+=1;usr.SubWeaponHUD()
				del src
			return
		for(var/obj/AmmoTypes/O in usr.Ammos)
			if(O.name==src.name)
				if(O.Ammo<O.MaxAmmo)
					usr<<sound('reload.ogg')
					O.Ammo=min(O.Ammo+round(src.MaxAmmo/20),O.MaxAmmo)
					usr.ReloadHUD();del src
				break
	verb/Stock()
		set src in oview(1)
		usr.GenericGet(src)
	verb/Drop()
		usr.GenericDrop(src)
	Click()
		if(src in usr.contents)
			for(var/obj/AmmoTypes/O in usr.Ammos)
				if(O.name==src.name)
					if(O.Ammo<O.MaxAmmo)
						O.Ammo=min(O.Ammo+round(src.MaxAmmo/10),O.MaxAmmo)
						usr.ReloadHUD();del src
					else	usr<<"[src.name] Full!"
					break
		else	src.Get()
	Hand_Gun_Ammo
		Ammo=250
		MaxAmmo=250
		icon_state="Hand Gun Ammo"
	Automatic_Ammo
		Ammo=600
		MaxAmmo=600
		icon_state="Automatic Ammo"
		New()
			spawn(1)	del src
	Shot_Gun_Ammo
		Ammo=100
		MaxAmmo=100
		icon_state="Shot Gun Ammo"
	Machine_Gun_Ammo
		Ammo=500
		MaxAmmo=500
		icon_state="Machine Gun Ammo"
	Sniper_Ammo
		Ammo=30
		MaxAmmo=30
		icon_state="Sniper Ammo"
	Rocket_Ammo
		Ammo=25
		MaxAmmo=25
		icon_state="Rocket Ammo"
	Grenade
		Ammo=1
		MaxAmmo=1
		icon='guns.dmi'
		icon_state="Grenade"
		New()
			src.verbs-=/obj/AmmoTypes/verb/Stock
			return ..()

obj/Weapon_Crate
	icon='objects.dmi'
	icon_state="crate"
	New()
		src.loc.density=1
		var/list/ItemList=list("Beretta","Pistol","Silenced_PP7","Revolver")
		while(src)
			for(var/obj/Guns/G in src.loc)	goto NoItem
			var/NP="/obj/Guns/Hand_Guns/[pick(ItemList)]"
			new NP(src.loc)
			NoItem
			sleep(rand(300,600))

obj/Ammo_Crate
	icon='objects.dmi'
	icon_state="crate"
	New()
		src.loc.density=1
		var/list/ItemList=typesof(/obj/AmmoTypes/)
		ItemList-=text2path("/obj/AmmoTypes")
		ItemList-=text2path("/obj/AmmoTypes/Rocket_Ammo")
		ItemList-=text2path("/obj/AmmoTypes/Automatic_Ammo")
		while(src)
			for(var/obj/AmmoTypes/G in src.loc)	goto NoItem
			var/O=pick(ItemList)
			new O(src.loc,0)
			NoItem;sleep(rand(300,600))


obj/Item_Crate
	icon='objects.dmi'
	icon_state="crate"
	New()
		src.loc.density=1
		var/list/ItemList=typesof(/obj/Items/)
		var/O=pick(ItemList)
		while(O==text2path("/obj/Items"))	O=pick(ItemList)
		new O(src.loc)

