obj/SpecialItems
	icon='Items.dmi'
	var/Price=0
	mouse_opacity=2
	verb/Drop()
		usr.GenericDrop(src)
	Get()
		set src in oview(1)
		usr.GenericGet(src)
	Car_Keys
		Price=150000
		icon_state="CarKeys"
		Drop()
			for(var/obj/Vehicles/V in world)
				if(V.Owner==usr)	VehicleExplode(V,V.TL.loc)
			usr.GenericDrop(src)
		Click()
			if(src in usr.contents)
				for(var/obj/Vehicles/V in world)
					if(V.Owner==usr)	{VehicleExplode(V,V.TL.loc);return}
				if(!usr.CanAct)	return
				if(usr.x==1 || usr.x==200 || usr.y==1 || usr.y==200)	return
				var/turf/T=locate(usr.x+1,usr.y,usr.z);if(T && !T.Enter(usr))	return
				T=locate(usr.x+1,usr.y-1,usr.z);if(T && !T.Enter(usr))	return
				T=locate(usr.x,usr.y-1,usr.z);if(T && !T.Enter(usr))	return
				var/obj/Vehicles/Jeep/J=new(usr.loc);J.Owner=usr
			return ..()

mob/proc/GenericGet(var/obj/O)
	if(get_dist(src,O)>1)	return
	if(src.contents.len<src.PackSize)
		O.DroppedBy=null
		src.contents+=O
		src.ItemHUD()
		src<<sound('reload.ogg')
	else	src<<"Inventory Full!"

obj/var/mob/DroppedBy=null
mob/var/list/DroppedItems=list()
mob/proc/GenericDrop(var/obj/O)
	if(!src.CanAct)	return
	if(!src.CashPointDrop(O))	return
	if(!(O in src.DroppedItems))	src.DroppedItems+=O
	if(O.suffix=="Equipped")
		O.suffix=null;src.Weapon=null
		src.ResetIS();src.EquipHUD()
	O.DroppedBy=src
	O.loc=src.loc
	src.ItemHUD()
	if(O.CashPointed)	del O

obj/ShopItems
	icon='Items.dmi'
	var/Price=100
	mouse_opacity=2
	Get()
		set src in oview(1)
		usr.GenericGet(src)
	verb/Drop()
		usr.GenericDrop(src)
	Teleport_Beacon
		Price=10000
		icon_state="Teleport Beacon"
		verb/Place_Entrance()
			if(!usr.CanAct)	return
			if(usr.loc:Portal)	return
			var/obj/Portals/Entrance/E=new(usr.loc)
			E.Owner=usr;usr.loc:Portal=E
			E.AddName(usr.name)
			usr.DisplayActions()
			for(var/obj/Portals/P in world)
				if(P.Owner==usr && P!=E)
					if(P.name=="Entrance")	del P
					else	if(P.name=="Exit")
						E.OtherSide=P;P.OtherSide=E
		verb/Place_Exit()
			if(!usr.CanAct)	return
			if(usr.loc:Portal)	return
			var/obj/Portals/Exit/E=new(usr.loc)
			E.Owner=usr;usr.loc:Portal=E
			E.AddName(usr.name)
			usr.DisplayActions()
			for(var/obj/Portals/P in world)
				if(P.Owner==usr && P!=E)
					if(P.name=="Exit")	del P
					else	if(P.name=="Entrance")
						E.OtherSide=P;P.OtherSide=E

mob/var/obj/HUD/TeleBar/TeleBar
obj/HUD/TeleBar
	icon='TeleBar.dmi'
	icon_state="1"
	screen_loc="8,11:-10"
	layer=21
mob/proc/AddTeleBar()
	if(!src.TeleBar)	src.TeleBar=new/obj/HUD/TeleBar
	src.client.screen-=src.TeleBar;src.client.screen+=src.TeleBar
obj/Portals
	var/mob/Player/Owner
	var/obj/Portals/OtherSide
	verb/UsePortal()
		set hidden=1
		set src in oview(1)
		if(src.OtherSide)
			if(usr.Vehicle)	return ..()
			usr.TeleportTo(src.OtherSide)
		else	usr<<"No Matching Portal..."
	Entrance
		icon='Items.dmi'
		icon_state="Teleport Entrance"
	Exit
		icon='Items.dmi'
		icon_state="Teleport Exit"

obj/Edible
	icon='Items.dmi'
	var/Price=100
	mouse_opacity=2
	New()
		src.desc="Consumable Item.  Restores [src.Price]% HP."
		return ..()
	Click()
		if(src in usr.contents)	src.Consume()
		else	src.Get()
	verb/Consume()
		usr.GiveHP(src.Price)
		del src
	verb/Drop()
		usr.GenericDrop(src)
	Get()
		set src in oview(1)
		usr.GenericGet(src)
	Snack_Bar
		Price=10
		icon_state="Snack Bar"
	Entree
		Price=50
		icon_state="Entree"
	Meal
		Price=100
		icon_state="Meal"
	Water
		Price=10
		icon_state="Water"
	Milk
		Price=50
		icon_state="Milk"
	Coffee
		Price=100
		icon_state="Coffee"

obj/Items
	icon='guns.dmi'
	var/Price=100
	mouse_opacity=2
	Get()
		set src in oview(1)
		usr.GenericGet(src)
	verb/Drop()
		usr.GenericDrop(src)
	Click()
		if(src in usr.contents)
		else	src.Get()
	Lighter
		icon_state="Lighter"
		Price=300
		Click()
			if(src in usr.contents)	usr<<"This Lighter Can be Used to Start Fires"
			return ..()
	Repair_Kit
		icon_state="Repair Kit"
		Price=500
		Click()
			if(src in usr.contents)	usr<<"These Tools allow you to Repair Damaged Objects"
			return ..()
	Vaccine
		icon_state="Vaccine"
		Click()
			if(src in usr.contents)
				if(usr.Infected)
					usr.Infected=0
					new/obj/BulletHit("Cure",usr,"Yes")
					usr.ItemHUD()
					usr.overlays-=VirusIcon
					usr<<"<b><font color=#66CCCC>You have been Vaccinated"
					del src
				else	usr<<"You arent infected!"
			return ..()