//Low CPU HUD Management
//ID is the "list" of HUD text to create/update
//First, use WriteHUDText(): Feed NewText as your max length string, ie: 9,999
//After that, just use UpdateHUDText() with the same ID and actual text for NewText
//hudx/hudpixx/etc should be easy enough positional variables to understand.
mob/var/list
	ObjectIDs=list()
	LastTextIDs=list()

obj/HUD/LowCPU
	layer=25
	icon='Text.dmi'
	var/OrigX;var/OrigPixX
	var/OrigY;var/OrigPixY
	var/OrigScreenLoc
	New(hudx,hudxpix,hudy,hudypix,letter)
		src.icon_state=letter
		src.OrigX=hudx;src.OrigPixX=hudxpix
		src.OrigY=hudy;src.OrigPixY=hudypix
		src.screen_loc="[hudx]:[hudxpix],[hudy]:[hudypix]"
		src.OrigScreenLoc=src.screen_loc

mob/proc/WriteHUDText(var/hudx,var/hudxpix,var/hudy,var/hudypix,var/ID,var/NewText)
	if(!src.client)	return
	var/firstpos=0
	var/PixelSpace=6
	NewText="[NewText]"
	var/list/IdList=list()
	if(!(ID in src.ObjectIDs))	{src.ObjectIDs+=ID;src.ObjectIDs[ID]=list()}
	for(var/obj/O in src.ObjectIDs["[ID]"])	del O
	while(src)
		firstpos+=1
		var/letter=copytext(NewText,firstpos,firstpos+1)
		if(!letter)	{src.ObjectIDs["[ID]"]=IdList;return}
		var/obj/HUD/LowCPU/O=new(hudx,hudxpix,hudy,hudypix,letter)
		src.client.screen+=O
		IdList+=O
		hudxpix+=PixelSpace
		if(hudxpix>=32)
			hudx+=1;hudxpix-=32

mob/proc/UpdateHUDText(var/ID,var/NewText)
	if(!src.client)	return
	var/firstpos=0
	NewText=uppertext("[NewText]")
	var/list/IdList=src.ObjectIDs["[ID]"]
	if(src.LastTextIDs[ID]==NewText && (IdList[1] in src.client.screen))	return

	if(!(ID in src.LastTextIDs))	src.LastTextIDs+=ID
	src.LastTextIDs[ID]=NewText

	if(!(ID in src.ObjectIDs))	{src.ObjectIDs+=ID;src.ObjectIDs[ID]=list()}
	src.client.screen-=IdList
	while(src)
		firstpos+=1
		var/letter=copytext(NewText,firstpos,firstpos+1)
		if(!letter)	return
		if(firstpos>IdList.len)	return
		var/obj/HUD/LowCPU/O=IdList[firstpos]
		if(O)
			O.icon_state=letter
			O.screen_loc=O.OrigScreenLoc
			src.client.screen+=O