mob/var/SaveVersion

client/Del()
	if(src.mob)
		if(src.mob.AntiVirus)	src.mob.Val+=100
		if(src.mob.Downed)	if(!("Wallet" in src.mob.Skills))
			src.mob.Val=round(src.mob.Val/2)
		src.mob.Save()
	return ..()

mob/verb/Save_Game()
	set hidden=1
	usr.Save()

mob/proc/Save()
	if(!src)	return
	if(!src.SaveMe)	return
	src<<"Saving Game..."
	src.SaveVersion=GameVersion
	var/savefile/F = new("Players/[ckey(src.key)].sav")
	F["SaveVersion"]<<src.SaveVersion
	F["contents"]<<src.contents
	F["HeadID"]<<src.HeadID
	F["Val"]<<src.Val
	F["Exp"]<<src.Exp
	F["Level"]<<src.Level
	F["Banked"]<<src.Banked
	F["Skills"]<<src.Skills
	F["Class"]<<src.Class
	F["SubWeapon"]<<src.SubWeapon
	F["MusicOn"]<<src.MusicOn
	F["TotalKills"]<<src.TotalKills
	F["SwatHead"]<<src.SwatHead
	F["SwatWeapon"]<<src.SwatWeapon
	F["SwatName"]<<src.SwatName
	F["CashPoints"]<<src.CashPoints
	F["CashPointsReceived"]<<src.CashPointsReceived
	F["StorageSize"]<<src.StorageSize
	F["Storage"]<<src.Storage
	F["name"]<<src.name
	F["FontColor"]<<src.FontColor
	F["NameColor"]<<src.NameColor
	F["VoiceSetText"]<<src.VoiceSetText
	if(src.Weapon)	F["WeaponName"]<<src.Weapon.name
	else	F["WeaponName"]<<null
	src<<"Game Saved"

mob/proc/Load()
	if(fexists("Players/[ckey(src.key)].sav"))
		var/savefile/F = new("Players/[ckey(src.key)].sav")
		F["SaveVersion"]>>src.SaveVersion
		F["HeadID"]>>src.HeadID
		F["Val"]>>src.Val
		F["Exp"]>>src.Exp
		F["Level"]>>src.Level
		F["Banked"]>>src.Banked
		F["Skills"]>>src.Skills
		F["Class"]>>src.Class
		F["SubWeapon"]>>src.SubWeapon
		F["MusicOn"]>>src.MusicOn
		F["TotalKills"]>>src.TotalKills
		F["SwatHead"]>>src.SwatHead
		F["SwatWeapon"]>>src.SwatWeapon
		F["SwatName"]>>src.SwatName
		F["CashPoints"]>>src.CashPoints
		F["CashPointsReceived"]>>src.CashPointsReceived
		F["StorageSize"]>>src.StorageSize
		F["Storage"]>>src.Storage
		F["name"]>>src.name
		F["FontColor"]>>src.FontColor
		F["NameColor"]>>src.NameColor
		F["VoiceSetText"]>>src.VoiceSetText
		F["contents"]>>src.contents
		var/WeaponName
		F["WeaponName"]>>WeaponName
		for(var/obj/Guns/O in src.contents)
			O.Ammo=O.MaxAmmo;O.suffix=null
		if(WeaponName)	for(var/obj/Guns/G in src.contents)
			if(G.name==WeaponName)	{G.Click(src);break}
		src.Move(null)
		src.SaveFixes()
		if(src.SaveVersion<GameVersion)	src.ViewUpdates()
		return 1
	else	return 0

mob/proc/SaveFixes()
	if(!src.VoiceSetText)	src.VoiceSetText=pick(VoiceSetHolder.VoiceSets)
	if(!src.name)	src.name=src.key
	if(!src.StorageSize)	src.StorageSize=5
	if(!src.Storage)	src.Storage=list()
	if(!src.CashPointsReceived)	{src.CashPoints=0;src.CashPointsReceived=list()}
	if(src.MusicOn==null)	src.MusicOn=1
	return