obj/Decoration
	Trash
		icon='Trash.dmi'
		layer=TURF_LAYER
		mouse_opacity=0
		New()
			src.icon_state="[rand(1,21)]"
			src.pixel_x=rand(-16,16)
			src.pixel_y=rand(-16,16)
			return ..()

obj/Supplemental/BulletHole
	icon='Effects.dmi'
	icon_state="BulletHole"
	mouse_opacity=0
	New(var/turf/T,var/px,var/py)
		//del src;return
		src.loc=T
		src.pixel_x=px-2
		src.pixel_y=py-2
		src.dir=pick(NORTH,SOUTH,EAST,WEST)
		spawn(300)	del src
		return ..()
turf
	var/Trapped=1
	var/obj/Portals/Portal
	Enter(var/mob/M)
		if(src.density && src.opacity)	return
		return ..()
	Entered(var/mob/Z)
		if(src.Trapped && istype(Z,/mob/Zombie))
			src.Trapped=0
			for(var/obj/Explosives/Mine/M in src)
				if(M.Owner)	Explode(M.loc,M.Owner,1)
				del M
		return ..()
	Click(location,control,params)
		if(get_dist(usr,src)>WorldView)	return
		if(!(src in oview(WorldView,usr)))	return
		var/NewDir=get_dir(usr,src)
		if(usr.dir!=NewDir)	usr.SetDir(NewDir)
		if(!usr.GenericFire())	return
		var/listy[]=params2list(params)
		var/iconx=listy["icon-x"]
		var/icony=listy["icon-y"]
		if(usr.Weapon.AmmoTypeName=="Rocket Ammo")	usr.FireRocket(src)
		else
			BreakWindowsInLocation(src)
			new/obj/Supplemental/BulletHole(src,text2num(iconx),text2num(icony))

turf/proc
	MakeTrash()
		if(src.z==1 && rand(1,10)==1)	new/obj/Decoration/Trash(src)

turf
	Location
		var/NewX=40;var/NewY=165;var/NewZ=1	//on the island
		New()
			if(!src.NewX)	src.NewX=src.x
			if(!src.NewY)	src.NewY=src.y
			if(!src.NewZ)	src.NewZ=src.z
			return ..()
		Entered(var/mob/M)
			if(ismob(M))
				if(M.Vehicle)	return
				sleep(8)
				if(M && M.loc==src)
					M.loc=locate(src.NewX,src.NewY,src.NewZ);M.LightHUD()
					M.ActivateZombies()

turf
	bloody
		icon='objects.dmi'
		density=0
		blooddrip
			icon_state="blooddrip"
		trailofblood
			icon_state="trailofblood"
		bloodsplatter
			icon_state="bloodsplatter"
	Supplemental
		Test_Tube
			icon='other.dmi'
			icon_state="TubeA"
			density=1
	Subway
		icon='subway.dmi'
		Tracks
			icon_state="TracksBright"
		Entrance
			icon_state="Entrance"
			opacity=1
		TurnAround
			density=0
			Entered(var/obj/O)
				if(istype(O,/obj/Supplemental/SubwayDriver))
					walk(O,0)
					spawn(100)	walk(O,src.dir,4)
	Interior
		icon='Interior.dmi'
		Interior_Wall
			density=1
			icon_state="IntWall"
		FancyWood
			density=1
			icon_state="FancyWood"
		BathroomWall
			density=1
			icon_state="BathroomWall"
		BedroomWall
			density=1
			icon_state="BedroomWall"
		Carpet
			icon_state="Carpet"
		Wooden
			icon_state="Wooden"
		Wooden2
			icon_state="Wooden2"
		Matting
			icon_state="Matting?"
		Railing
			density=1
			icon_state="Railing"
		BathroomTile
			icon_state="BathroomTile"
		Cabinets
			density=1
			icon_state="Cabinets"
		ChinaCabinet
			density=1
			icon_state="ChinaCabinet"
		StoveTop
			density=1
			icon_state="StoveTop"
		SinkTop
			density=1
			icon_state="SinkTop"
	basic
		icon='turfs.dmi'
		grass
			icon_state="grass"
			New()
				src.MakeTrash()
				return ..()
		road
			icon_state="black"
			New()
				src.MakeTrash()
				return ..()
		sidewalk
			icon_state="sidewalk"
			New()
				src.MakeTrash()
				return ..()
		line
			icon_state="line"
		wall
			icon_state="wall"
			density=1
			opacity=0
		Pole
			icon_state="Pole"
			density=1
		floor
			icon='cityturfs.dmi'
			icon_state="Ground2"
		Counter
			icon_state="counter"
			density=1
		Ladder
			icon_state="Ladder"
			density=1
			Enter()
				if(istype(usr,/mob/Player))	usr.GenericLoc(src)
				return ..()
		Tree
			icon='tree.dmi'
			icon_state="0,0"
			density=0
			New()
				//set density of this to match
				//dense tree
				/*new/obj/Tree_Dense(src,0,1)
				new/obj/Tree_Dense(src,1,1)
				new/obj/Tree_Dense(src,0,2)
				new/obj/Tree_Dense(src,1,2)
				new/obj/Tree_Dense(src,1,0)*/
				//non dense tree
				new/obj/Supplemental/Tree_Block(src,1,0)
				new/obj/Supplemental/Tree_Block(src,0,1)
				new/obj/Supplemental/Tree_Block(src,1,1)
				new/obj/Supplemental/Tree_Block(src,0,2)
				new/obj/Supplemental/Tree_Block(src,1,2)
		Grave
			icon_state="grave"
		Grave_Stone
			icon='objects.dmi'
			icon_state="grave"
			density=1
		Stairs
			icon='cityturfs.dmi'
			icon_state="Stairs"
		Stairs
			icon='cityturfs.dmi'
			icon_state="Stairs"
	Spacey
		icon='Spacey.dmi'
		Tile
			icon_state="Tile"
	Exteriors
		icon='Exteriors.dmi'
		GrayBricks
			density=1
			icon_state="GrayBricks"
		BlackBricks
			density=1
			icon_state="BlackBricks"
		WhiteTile
			icon_state="Tile"
		AngleTiles
			icon_state="AngleTiles"

obj/Supplemental
	Subway
		icon='Subway.dmi'
		pixel_x=-16
		Subway_Car
			icon_state="EntranceBL"
			layer=MOB_LAYER+1
		Subway_Car_Floor
			icon_state="Floor"
	Tree_Block
		icon='tree.dmi'
		icon_state="1,0"
		density=0
		layer=MOB_LAYER+5
		New(var/turf/T,var/i1,var/i2)
			if(!T)	return
			src.icon_state="[i1],[i2]"
			if(i2==0)	src.layer=TURF_LAYER
			src.loc=locate(T.x+i1,T.y+i2,T.z)
	Tree_Dense
		icon='tree.dmi'
		density=1
		layer=MOB_LAYER+1
		New(var/turf/T,var/i1,var/i2)
			src.loc=locate(T.x+i1,T.y+i2,T.z)
			src.icon_state="[i1],[i2]"

turf
	icon='turfs.dmi'
	Black
		icon_state="Black"
		density=1
		opacity=1
	Water
		icon_state="Water"
		density=1
		Enter(var/mob/M)
			return ..()	//Cancel Swim
			if(ismob(M))
				if(M.Vehicle)	return
				if(M.client && !("Swim" in M.Skills))	return
				else	return 1
			return ..()
		Entered(var/mob/M)
			if(ismob(M) && !istype(M,/mob/Player/Drones))
				M.icon_state="Swim";M.CanAct=0
			return ..()
		Exited(var/mob/M)
			if(ismob(M))
				M.ResetIS();M.CanAct=1
			return ..()
	City_Furniture
		icon='cityobjects.dmi'
		density=1
		Fire_Hydrant
			icon_state="Hydrant"
		Trash_Can
			icon_state="Trash Can"
		Sky_Light
			icon_state="Sky Light"
		Caution_Sign
			icon_state="Caution"
		Support_Structure
			icon_state="Support Structure"
			layer=MOB_LAYER+5
		Power_Lines
			icon_state="Power Lineb"
			layer=MOB_LAYER+5
		Mail_Box
			icon_state="Mail Box"
		Air_Conditioning_Unit
			icon_state="AC"
		Graffiti
			icon_state="Graffiti"
	City
		icon='cityturfs.dmi'
		density=1
		Window
			icon_state="w1"
		Wall
			icon_state="w3"
		Wooden_Doors
			icon_state="d"
		Door
			icon_state="d1"
		Road
			icon_state="ro"
			density=0
			New()
				src.MakeTrash()
				return ..()
		Side_Walk
			icon_state="s"
			density=0
			New()
				src.MakeTrash()
				return ..()
		Roof
			icon_state="r1"
			opacity=1
		Entrance
			icon_state="Entrance"
			density=0
		Stairs
			icon_state="Stairs"
			density=0
		Fire_Escape
			icon_state="Fire Escape"
			density=0
		Bricks
			icon_state="b"
		Fan
			icon_state="Fan"
		Ground
			icon_state="Ground"
			density=0
		InduStrial_Building
			icon_state="i"

turf
	var/State=""
	MultiDoor
	Supplemental
		SubwayExit
			Enter(var/mob/M)
				if(ismob(M))	return ..()
				else	return
			Entered(var/mob/M)
				if(ismob(M))	M.ResetIS()
			Exit(var/mob/M)
				if(ismob(M))
					if(M.dir==SOUTH)
						M.CanAct=1;return ..()
					for(var/obj/Supplemental/Subway/Subway_Car/C in get_step(M,M.dir))
						M.CanAct=0;return ..()
					return
				else	if(istype(M,/atom))
					//keeps barricades off the tracks
					if(M.dir==SOUTH)	return ..()
					else
						step(M,SOUTH);return
				return ..()

obj/Supplemental
	Barrel
		icon='CityObjects.dmi'
		icon_state="Barrel"
		density=1
	Switch
		icon='other.dmi'
		icon_state="Switch"
		density=1
		var/Activated=0
		verb/Activate()
			set hidden=1
			set src in oview(1)
			if(src.Activated==0)
				src.Activated=1
				view(WorldView)<<sound('close.ogg')
				src.dir=EAST
				for(var/turf/MultiDoor/T in oview(WorldView,src))
					if(T.State!="broken")
						var/obj/TurfType/Window/W=new(T)
						W.name=T.name
						W.icon_state="[T.State][T.name]"
						T.density=1
						W.HP=500
						W.MaxHP=500
			else
				src.Activated=0
				view(WorldView)<<sound('open.ogg')
				src.dir=NORTH
				for(var/turf/MultiDoor/T in oview(WorldView,src))
					if(T.State!="broken")
						for(var/obj/TurfType/Window/W in T)
							del W
						T.density=0

	SubwayDriver
		New()
			spawn(50)
				for(var/obj/Supplemental/Subway/S in oview(2,src))
					S.pixel_x+=32*(S.x-src.x);S.pixel_y+=32*(S.y-src.y)
					src.overlays+=S;S.icon_state="invis"
				walk(src,WEST,4)
			return ..()
		Move(turf/NewLoc,NewDir)
			for(var/obj/Supplemental/Subway/S in oview(2,src))
				S.loc=locate(NewLoc.x-(src.x-S.x),S.y,S.z)
			for(var/mob/Player/M in oview(1,src))
				M.icon_state="In Car";M.dir=NewDir
				M.loc=locate(NewLoc.x-(src.x-M.x),M.y,M.z)
			return ..()
	Dam
		icon='turfs.dmi'
		icon_state="dam1"
		density=1

obj
	TurfType
		HP=30
		MaxHP=30
		var/hp
		var/maxhp
		New()
			if(src.maxhp)
				src.HP=src.hp;src.MaxHP=src.maxhp
			src.loc.density=src.density
			src.verbs-=/obj/TurfType/verb/Repair
		verb/Repair()
			set src in oview(1)
			src.RepairProc(usr)
		Door
			icon='cityturfs.dmi'
			icon_state="Door"
			density=1
			opacity=1
			var/OpenSound='Open.ogg'
			var/CloseSound='Close.ogg'
			var/broken=0
			proc/BreakDoor()
				if(src.HP<=0)
					src.SetOpacity(0)
					src.broken=1
					src.density=0
					src.loc.density=0
					src.icon_state="Broken[src.name]"
					src.verbs+=/obj/TurfType/verb/Repair
		Window
			icon='turfs.dmi'
			icon_state="window"
			name="window"
			density=1
			proc
				BreakWindow(/**/)
					var/obj/TurfType/Window/M=src
					if(!M.density)	return
					if(M.HP>=300 && M.HP<=400)
						M:icon_state="hit[src.name]"
						src.loc:State="hit"
					if(M.HP>=200 && M.HP<=300)
						M:icon_state="cracked[src.name]"
						src.loc:State="cracked"

					if(M:HP<=20)
						M:icon_state="hit[src.name]"
						src.loc:State="hit"
					if(M:HP<=10)
						M:icon_state="cracked[src.name]"
						src.loc:State="cracked"
					if(M:HP<=0)
						view(WorldView,M)<<sound('break.ogg',0,0,0)
						M.density=0
						M.loc.density=0
						M.icon_state="broken[src.name]"
						src.loc:State="broken"
						src.verbs+=/obj/TurfType/verb/Repair


mob/verb/Open()
	set hidden=1
	for(var/obj/TurfType/Door/D in get_step(usr,usr.dir))
		if(D.broken)
			usr<<"The [D.name] is broken!";return
		if(D.density)
			D.icon_state="open[D.name]"
			D.density=0
			D.SetOpacity(0)
			D.loc.density=0
			view(WorldView)<<sound(D.OpenSound)
		else
			D.icon_state="[D.name]"
			D.density=1
			D.SetOpacity(1)
			D.loc.density=1
			view(WorldView)<<sound(D.CloseSound)