var/ZombieRange=8
var/mob/CarExploderMob=new/mob/Player(locate(world.maxx,world.maxy,1))
mob/Zombie
	icon='ZombieLegs.dmi'
	var/mob/OnFireBy
	var/mob/MobTarget
	var/obj/ObjTarget
	var/BodyType="Male"
	var/BodyNum=1
	var/Hunting=0
	var/HeadNum=1
	var/Strength=7
	var/MinSpeed=10
	var/MaxSpeed=20
	//var/HeadNum=1
	mouse_over_pointer="Target"
	HP=0
	sight=SEE_MOBS
	New()
		Zombies+=src
		src.BodyType=pick("Male","Male","Girl","Fat")
		src.SetupZombie()
		src.BodyNum=rand(1,5)
		src.HeadNum=rand(1,5)
		new/obj/ZombieParts/Torso(src)
		src.HeadIcon=new/obj/ZombieParts/Head(src)
		src.icon_state="[src.BodyType][src.BodyNum]"
		spawn(rand(src.MinSpeed*10,src.MaxSpeed*10))	src.Wander()
	Del()
		if(Zombies.len>ZombieMax)
			Zombies-=src;return ..()
		src.loc=locate(200,200,1)
		src.SetupZombie()
		walk(src,0)
		src.OnFireBy=null
		src.overlays=list()
		new/obj/ZombieParts/Torso(src)
		src.HeadIcon=new/obj/ZombieParts/Head(src)
		src.LocateZombie()
		return

	Click(location,control,params)
		if(get_dist(src,usr)>WorldView)	return
		if(!(src in oview(WorldView,usr)))	return
		var/listy[]=params2list(params)
		var/icony=listy["icon-y"]
		if(!usr.GenericFire())	return
		usr.ShotsHit+=1
		usr.ShootZombie(src,usr,text2num(icony))

	proc/SetupZombie()
		if(src.BodyType=="Male" || src.BodyType=="Girl")
			src.HP=rand(50,100)
		if(src.BodyType=="Girl")
			src.Strength=3;src.MinSpeed=5;src.MaxSpeed=10
		if(src.BodyType=="Fat")
			src.HP=rand(150,300)
			src.Strength=20;src.MinSpeed=20;src.MaxSpeed=40

	proc/SetOnFireBy(var/mob/M)
		if(!src.OnFireBy)
			src.OnFireBy=M;walk_rand(src,2)
			src.overlays+=OnFireOverlay
			spawn(rand(20,30))	if(M && src.OnFireBy==M)
				src.HP=0;M.Killed(src)

	proc/ZombieAttackBounce()
		if(src.pixel_x!=0 || src.pixel_y!=0)	return
		if(src.dir==NORTH || src.dir==NORTHWEST)	src.pixel_y=2
		if(src.dir==SOUTH || src.dir==SOUTHEAST)	src.pixel_y=-2
		if(src.dir==EAST || src.dir==NORTHEAST)	src.pixel_x=2
		if(src.dir==WEST || src.dir==SOUTHWEST)	src.pixel_x=-2
		spawn(2)	if(src)	if(src.pixel_x==0 || src.pixel_x==2 || src.pixel_x==-2)
			if(src.pixel_y==0 || src.pixel_y==2 || src.pixel_y==-2)
				src.pixel_x=0;src.pixel_y=0

	proc/Wander()
		spawn()	while(src)
			if(!src.Hunting)
				if(DayTime)	step_rand(src)
				else	if(!step_to(src,NightPoint))	step_rand(src)
			sleep(rand(50,300))

	proc/TargetPlayer()
		if(!src.MobTarget)	//find a player to target
			for(var/mob/Player/M in oview(ZombieRange,src))
				if(M.MyInvis || M.icon_state=="Swim")	continue
				src.MobTarget=M;break
	proc/TargetCades()
		if(src.MobTarget && !src.ObjTarget)//only while targeting player and not targeting an object
			for(var/obj/Barracades/B in oview(ZombieRange,src))//target any baracades
				if(B.HP<=0 || !B.density)	continue
				if(get_dist(src,B)<get_dist(src,src.MobTarget))//between zombie and player
					if(get_dist(src.MobTarget,B)<get_dist(src.MobTarget,src))//between player and zombie
						if(src.ObjTarget)	if(get_dist(src,src.ObjTarget)<=get_dist(src,B))	continue
						//if(step_to(src,B,1))
						src.ObjTarget=B;break//attacks the closest object they can get to
						//else	break
	proc/TargetVehicles()
		if(src.MobTarget && !src.ObjTarget)
			for(var/obj/VehiclePart/V in oview(ZombieRange,src))//target any Vehicles
				if(V.Vehicle.HP<=0)	continue
				if(get_dist(src,V)<get_dist(src,src.MobTarget))
					if(get_dist(src.MobTarget,V)<get_dist(src.MobTarget,src))
						if(src.ObjTarget)	if(get_dist(src,src.ObjTarget)<=get_dist(src,V))	continue
						src.ObjTarget=V;break
	proc/TargetDoorsWindows()
		if(src.MobTarget && !src.ObjTarget)
			for(var/obj/TurfType/T in oview(ZombieRange,src))//target windows/doors
				if(T.HP<=0 || !T.density)	continue
				if(get_dist(src,T)<get_dist(src,src.MobTarget))
					if(get_dist(src.MobTarget,T)<get_dist(src.MobTarget,src))
						if(src.ObjTarget)	if(get_dist(src,src.ObjTarget)<=get_dist(src,T))	continue
						//if(step_to(src,T,1))
						src.ObjTarget=T;break
						//else	break
	proc/AttackMob()
		if(get_dist(src,src.MobTarget)<=1)
			if(!src.MobTarget.Vehicle)
				if(!src.MobTarget.Infected && src.MobTarget.client && !src.MobTarget.AntiVirus && !("Immunity" in src.MobTarget.Skills))
					src.MobTarget.Infected=1
					src.MobTarget.overlays-=VirusIcon
					src.MobTarget.overlays+=VirusIcon
					//src.MobTarget<<"<b><font color=green>You have been Infected!"
				src.dir=get_dir(src,src.MobTarget)
				src.ZombieAttackBounce()
				src.MobTarget<<sound(pick('flesh1.ogg','flesh2.ogg','flesh3.ogg'))
				src.MobTarget.Infected=1
				if(!src.MobTarget)	return 1
				var/Damage=rand(src.Strength-1,src.Strength+1)
				src.MobTarget.HP-=Damage
				src.MobTarget.HealthHUD()
				DamageShow(src.MobTarget,Damage,'DamageNumsG.dmi')
				src.MobTarget.ZombieStun(src)
				if(src.MobTarget.HP<=0)
					src.MobTarget.DeathCheck()
					src.MobTarget=null
			else
				var/obj/Vehicles/V=src.MobTarget.Vehicle.Vehicle
				view(WorldView,src.ObjTarget)<<sound('Close.ogg')
				src.dir=get_dir(src,src.MobTarget)
				src.ZombieAttackBounce()
				var/Damage=rand(src.Strength-1,src.Strength+1)
				V.HP-=Damage
				if(V.HP<=0)
					VehicleExplode(V,src.MobTarget.loc)
		else	if(step_to(src,src.MobTarget,1))
		else	step_rand(src)
	proc/AttackObject()
		if(istype(src.ObjTarget,/obj/VehiclePart))
			if(src.ObjTarget:Vehicle.HP<=0)
				src.ObjTarget=null;return 1
		else
			if(src.ObjTarget.HP<=0)
				src.ObjTarget=null;return 1
		if(get_dist(src,src.ObjTarget)<=1)
			view(WorldView,src.ObjTarget)<<sound('Close.ogg')
			src.dir=get_dir(src,src.ObjTarget)
			src.ZombieAttackBounce()
			var/Damage=rand(src.Strength-1,src.Strength+1)
			if(istype(src.ObjTarget,/obj/VehiclePart))
				var/obj/Vehicles/V=src.ObjTarget:Vehicle
				view(WorldView,src.ObjTarget)<<sound('Close.ogg')
				src.dir=get_dir(src,src.ObjTarget)
				src.ZombieAttackBounce()
				V.HP-=Damage
				if(V.HP<=0)
					VehicleExplode(V,src.ObjTarget.loc)
			else
				AttackBounceAtom(src.ObjTarget)
				src.ObjTarget.HP-=Damage
				if(src.ObjTarget.HP<=0)
					if(istype(src.ObjTarget,/obj/TurfType/Window))	src.ObjTarget:BreakWindow()
					if(istype(src.ObjTarget,/obj/TurfType/Door))	src.ObjTarget:BreakDoor()
					if(istype(src.ObjTarget,/obj/Barracades))	BarracadeBreak(src.ObjTarget)
		else	if(step_to(src,src.ObjTarget,1))
		else	step_rand(src)
	proc/Hunt()
		src.Hunting=1
		if(!CheckMaxCPU())	{src.Hunting=0;return}
		if(src.OnFireBy)
			src.MobTarget=null
			src.ObjTarget=null
			src.Hunting=0;return
		if(src.MobTarget && src.MobTarget.MyInvis)	src.MobTarget=null
		if(src.MobTarget && src.MobTarget.icon_state=="Swim")	src.MobTarget=null
		if(src.MobTarget && get_dist(src,src.MobTarget)>ZombieRange*2)	src.MobTarget=null
		if(src.ObjTarget && get_dist(src,src.ObjTarget)>ZombieRange*2)	src.ObjTarget=null
		if(src.MobTarget && src.MobTarget.client && !(src.MobTarget in oview(ZombieRange*2,src)))	src.MobTarget=null

		src.TargetPlayer()

		if(!src.MobTarget)
			src.ObjTarget=null
			src.Hunting=0;return

		if(src.MobTarget)
			for(var/mob/Player/M in oview(WorldView,src))
				if(M.client)	M.PlayZombieSound(src)

		src.TargetCades()
		src.TargetVehicles()
		src.TargetDoorsWindows()

		if((src.MobTarget && !src.ObjTarget) || get_dist(src,src.MobTarget)<=get_dist(src,src.ObjTarget))//attack players
			if(src.AttackMob())	goto CanceledTarget
		else	if(src.ObjTarget)	//attack objects
			if(src.AttackObject())	goto CanceledTarget
		CanceledTarget
		if(src.MobTarget || src.ObjTarget)	spawn(rand(src.MinSpeed,src.MaxSpeed))	src.Hunt()
		else	src.Hunting=0

mob/proc/ZombieStun(var/mob/Zombie/Z)
	if(!src.ZombieStun)
		Z.layer=src.layer+1
		src.ZombieStun=Z
		if(Z.dir==NORTH)	Z.pixel_y=16
		if(Z.dir==SOUTH)	Z.pixel_y=-16
		if(Z.dir==EAST)	Z.pixel_x=24
		if(Z.dir==WEST)	Z.pixel_x=-24
		if(Z.dir==NORTHEAST)	{Z.pixel_x=24;Z.pixel_y=16}
		if(Z.dir==NORTHWEST)	{Z.pixel_x=-24;Z.pixel_y=16}
		if(Z.dir==SOUTHEAST)	{Z.pixel_x=24;Z.pixel_y=-16}
		if(Z.dir==SOUTHWEST)	{Z.pixel_x=-24;Z.pixel_y=-16}
		spawn(30)
			if(src && Z && src.ZombieStun==Z)	src.ZombieStun=null
			if(Z)	{Z.layer=initial(Z.layer);Z.pixel_x=0;Z.pixel_y=0}

proc/AttackBounceAtom(var/atom/A)
	A.pixel_y=2
	spawn(1)	if(A)	A.pixel_y=0

proc/VehicleExplode(var/obj/Vehicles/V,var/ExploLoc)
	for(var/obj/VehiclePart/P in V.Parts)
		var/mob/M=P.Passanger;del P
		if(M)	M.ResetIS()
	del V
	ShowExplosion(ExploLoc)

mob/proc/DeathCheck(var/Method=0)
	if(src.HP<=0)
		if(src.Downed || !src.client)
			if(src.client)
				if(Method=="Downed")	world<<"<b><font color=red>[src] has Bled to Death! ([src.Kills] Kills)"
				else	if(Method==1)	world<<"<b><font color=red>[src] has Committed Suicide! ([src.Kills] Kills)"
				else	if(Method==2)	world<<"<b><font color=red>[src] has Starved to Death! ([src.Kills] Kills)"
				else	world<<"<b><font color=red>[src] has been Eaten Alive! ([src.Kills] Kills)"
			else
				if(istype(src,/mob/Player/Command_Post) || istype(src,/mob/Player/Recap_Post))
					if(src.name=="Head Quarters Command Post")
						world<<"<font color=red>All Hope has been Lost!"
						world.Reboot();return
					else
						var/FG="<font color=gray>"
						world<<"<b>[FG]The [src.name] CP has been <font color=red>Overrun[FG] at [src.x], [src.y]!"
						for(var/obj/Command_Posts/CP_Spawner/CPS in world)	if(CPS.name==src.name)	{CapturedCPs-=CPS;UnCapturedCPs+=CPS}
						for(var/obj/Job_Spawner/J in world)	if(J.RequiredCP==src.name)
							J.invisibility=0
							if(J.JobMob)	del J.JobMob
				del src;return
		else	src.DownPlayer()
	/*if(src.Infection>=100 && src.client)
		src.HP=0;world<<"<b><font color=red>[src] has died of Infection! ([src.Kills] Kills)"*/
	if(src.HP<=0)
		if(src.client)
			if(src.RcD)	del src.RcD
			if(!("Wallet" in src.Skills))
				src.Val=round(src.Val/2)
				src.ValHUD()
				src<<"Lost [src.Val] Val!"
			src.RevivePlayer()
			src.DeathReset()
			src.Respec()
		else	del src

var/obj/Supplemental/OnFireOver/OnFireOverlay=new
obj/Supplemental
	OnFireOver
		layer=FLOAT_LAYER
		icon='Effects.dmi'
		icon_state="Burn"

obj/proc
	BurnBody(var/mob/M)
		var/CanBurn=0
		if(M)	{usr=M;CanBurn=1}
		if(usr.Vehicle)	return
		if("Pyromaniac" in usr.Skills)	CanBurn=1
		for(var/obj/Items/Lighter/L in usr.contents)	CanBurn=1
		if(CanBurn)	if(src.icon_state!="invis")
			usr.GiveVal(1)
			CorpseList-=src
			src.icon_state="invis"
			src.overlays+=OnFireOverlay
			spawn(30)	del src
			return 1
		else
			usr<<"You need a Lighter to Burn Bodies!";return 0

obj/ZombieParts
	layer=FLOAT_LAYER
	Head
		icon='ZombieHeads.dmi'
		New(var/mob/Zombie/M)
			src.loc=null
			src.icon_state="[M.BodyType][M.HeadNum]"
			M.overlays+=src
	Torso
		icon='ZombieTorsos.dmi'
		New(var/mob/Zombie/M)
			src.loc=null
			src.icon_state="[M.BodyType][rand(1,5)]"
			M.overlays+=src

obj/Corpse
	icon='ZombieTorsos.dmi'
	icon_state="Male1 Corpse"
	New(var/mob/Zombie/Z,var/body,var/obj/heady,var/headn,var/obj/AT)
		if(body)
			var/Body2Use=Z.BodyType
			if(Body2Use=="Fat")	Body2Use="Male"
			src.icon_state="[Body2Use][body] Corpse"
			if(heady)	{heady.icon_state="[Body2Use][body] Corpse";src.overlays+=heady}
			src.loc=Z.loc
			//Ammo Drops
			/*for(var/obj/AmmoTypes/T in src.loc)	goto NoAmmo
			if(rand(1,50)==1)
				new/obj/AmmoTypes/Grenade(src.loc);goto NoAmmo
			if(rand(1,25)==1 && AT && "[AT]"!="Rocket Ammo")
				var/NT=AT.type;new NT(src.loc)
			NoAmmo*/
			spawn()	while(src)
				sleep(rand(150,300))
				if(!(src in CorpseList))	del src